/*
    The source code contained within this file is protected under the
    laws of the United States of America and by International Treaty.
    Unless otherwise noted, the source contained herein is:

    Copyright (c)1990, 1991, 1992 BecknerVision Inc - All Rights Reserved

    Written by John Wm Beckner        THIS NOTICE MUST NOT BE REMOVED
    BecknerVision Inc
    PO Box 11945                      SOURCE CODE (THIS FILE) MAY NOT BE
    Winston-Salem NC 27116            DISTRIBUTED!  ONLY REGISTERED USERS
    Fax: 919/760-1003                 OF BECKNER LIBRARY & UTILITIES II MAY
                                      BE IN POSSESSION OF THIS FILE.
*/

#include "beckner.inc"
#include "inkey.ch"

FUNCTION aRead(aLines, cFilename, nStartLine, nNumLines, aDelims)
   LOCAL nHandle, nCtr := 1, cHold, lExit := .n.
   IF ValType(aLines)!="A"
      aDelims    := nNumLines
      nNumLines  := nStartLine
      nStartLine := cFilename
      cFilename  := aLines
      aLines     := {}
   ENDIF
   nHandle := fOpen(cFilename)
   DEFAULT nStartLine TO 1, nNumLines TO fNumLines(nHandle)
   WHILE --nStartLine>0
      fReadLine(nHandle)
   ENDWHILE
   aSize(aLines, nNumLines)
   WHILE nNumLines-- >0
      aLines[nCtr++] := fReadLine(nHandle)
      IF Chr(K_CTRL_Z)$aLines[nCtr-1]
         aLines[nCtr-1] := Left(aLines[nCtr-1], At(Chr(K_CTRL_Z),;
               aLines[nCtr-1])-1)
         lExit := .y.
      ENDIF
      IF aDelims!=NIL
         cHold          := aLines[nCtr-1]
         aLines[nCtr-1] := {}
         aEval(aDelims, {|cDelimiter| aAdd(aLines[nCtr-1],;
               sParse(@cHold, cDelimiter))})
      ENDIF
      IF lExit
         EXIT
      ENDIF
   ENDWHILE
   aSize(aLines, nCtr-1)
   fClose(nHandle)
   RETURN aLines
ENDFUNCTION

/*
 1.02 01.24.93 Added parsed line capability, aDelim
*/
