/*
 * File......: BARCLEAR.PRG
 * Author....: Martin Colloby
 * BBS.......: The Dark Knight Returns
 * Net/Node..: 050/069
 * User Name.: Martin Colloby
 * Date......: 18/4/93
 * Revision..: 1.0
 *
 * This is an original work by Martin Colloby and is placed in the public
 * domain.
 *
 * Modification history:
 * ---------------------
 *
 * $Log$
 *
 */


/*  $DOC$
 *  $FUNCNAME$
 *      GT_BARCLEAR()
 *  $CATEGORY$
 *      Video
 *  $ONELINER$
 *      Clear the bar area on the screen
 *  $SYNTAX$
 *      GT_BarClear()
 *  $ARGUMENTS$
 *      None
 *  $RETURNS$
 *      NIL
 *  $DESCRIPTION$
 *      Clears the area used to display bars on screen.  Assumes that the
 *      user has output a bar, and wishes to output another.
 *  $EXAMPLES$
 *
 *  $SEEALSO$
 *
 *  $INCLUDE$
 *      GT_LIB.CH
 *  $END$
 */

*
#include "GT_lib.ch"

FUNCTION GT_BarClear()

/*****************************************************************************
 Purpose - Clear the bar area
 Returns - None
 Author  - Martin Colloby
 Created - 13/11/91
******************************************************************************
 Parameters - None
 Privates   - None
 Locals     - None
 Externals  - None
*****************************************************************************/

@ MAXROW() - 4 , 20 SAY "                                        "

RETURN NIL
*
