/*
    The source code contained within this file is protected under the
    laws of the United States of America and by International Treaty.
    Unless otherwise noted, the source contained herein is:

    Copyright (c)1990, 1991, 1992 BecknerVision Inc - All Rights Reserved

    Written by John Wm Beckner        THIS NOTICE MUST NOT BE REMOVED
    BecknerVision Inc
    PO Box 11945                      SOURCE CODE (THIS FILE) MAY NOT BE
    Winston-Salem NC 27116            DISTRIBUTED!  ONLY REGISTERED USERS
    Fax: 919/760-1003                 OF BECKNER LIBRARY & UTILITIES II MAY
                                      BE IN POSSESSION OF THIS FILE.
*/

#include "beckner.inc"
#include "alias.ch"
#include "dbstruct.ch"
#include "inkey.ch"

EXTERNAL fCompute, pVarMake, pVarRelease, dMMYY, ffillin, rSkip, dbGoto
EXTERNAL dbSeek, dbGoTop, dbGoBottom

MEMVAR x,a,line,page,currec,flt_status,flt_string,wscreen,xscreen,cursel,fill_in,GetList, cxc, sel__ctr, aa
MEMVAR formx,form_type, cAltFile, aVars, cPrefix, cd, wrow, wcol, opt, start_rec
MEMVAR prow, pcol, curpol, temp_rec, oldwhere, ml, mw, xstr, arc, ctemp, ccc
MEMVAR berror, ggg, prfx, noption, long, rr_adder, c_lines, last_rr, maybe, xx
MEMVAR aaaaa, nctr, ndone, currctr, rrr, exp, ___width, ___tab, ___wrap
MEMVAR ___max, ___lines, ___x, i, cl, tr, del_before, cratio1, cratio2, rratio1
MEMVAR rratio2, rrch, ccch, zap_em, nm, old_form, zscreen, choice, fld
MEMVAR buffer, ctext, nhandle, syscolor, color_set, ctemp2, st_no, mcro, ctr
MEMVAR Cond_Sel, sel_fnd, prefix, startrec, descrip, fieldname, option, flds
MEMVAR cline, nstart, bb, bb_chk, form_opt, oldopt, max_forms, sel_max
MEMVAR sel_areas
FIELD Form_No, Name, Dbf_Prefix, Dbf_A, dbf_b, dbf_c, dbf_d, dbf_e, dbf_f, dbf_g
FIELD dbf_h, ntx_a, ntx_b, ntx_c, ntx_d, ntx_e, ntx_f, ntx_g, ntx_h, length
FIELD stagger, adder, flt_a, flt_b, flt_c, flt_d, flt_e, flt_f, flt_g, flt_h
FIELD rel_b, rel_c, rel_d, rel_e, rel_f, rel_g, rel_h, alignment, notes, single
FIELD st_codes, en_codes, ma_start, ma_stop, ma_use, ma_times, mcr_tabs, mcr_width
FIELD where, prelimexpr, whileexp, nextrecs, restrecs, var, prompt, rr, cc
FIELD expression, desc, prt_not_e, no_compres, bold, uline, max_rows, alt_col
FIELD cond_st, cond_end, condition, sel_usefnd, cond_ctr, prelim_exp
FIELD field_name, field_type, field_len, field_dec, filename, funcname, for_type
FIELD p1_prompt, p1_type, p1_len, p2_prompt, p2_type, p2_len, p3_prompt, p3_type, p3_len
FIELD op_name, operand, use_f2, modifier, alias

FUNCTION BecknerFG(p1, p2, p3, p4, p5)
/* NOTE THAT THIS HAS NOT BEEN UPDATED TO BECKNERVISION'S CLIPPER 5 STANDARD */
   LOCAL cVersion := "2.5", GetList := {}
   priv formx := p1, form_type := p2, cAltFile := p3, aVars := p4
   priv cPrefix := p5
   priv x,a,line,page,currec,flt_status,flt_string,wscreen,xscreen,cursel,fill_in
   ishare(.y.)
   DEFAULT cPrefix to "BV"
   if !file(cPrefix+'FM.DBF')
      aa=cPrefix+'FM/FORM_NO/C/5/NAME/C/40/DBF_PREFIX/C/2/DBF_A/C/8/DBF_B/C/8/DBF_C/C/8'
      aa=aa+'/DBF_D/C/8/DBF_E/C/8/DBF_F/C/8/DBF_G/C/8/DBF_H/C/8/NTX_A/C/8/'
      aa=aa+'NTX_B/C/8/NTX_C/C/8/NTX_D/C/8/NTX_E/C/8/NTX_F/C/8/NTX_G/C/8/'
      aa=aa+'NTX_H/C/8/LENGTH/N/3//STAGGER/L/ADDER/N/1//FLT_A/C/200/FLT_B/C/200/'
      aa=aa+'FLT_C/C/200/FLT_D/C/200/FLT_E/C/200/FLT_F/C/200/FLT_G/C/200/'
      aa=aa+'FLT_H/C/200/REL_B/C/20/REL_C/C/20/REL_DE/C/20/REL_E/C/20/REL_F/C/20/'
      aa=aa+'REL_G/C/20/REL_H/C/20/ALIGNMENT/L/NOTES/M/SINGLE/L/ST_CODES/C/6/'
      aa=aa+'EN_CODES/C/6/MA_START/C/8/MA_STOP/C/8/MA_USE/C/8/MA_TIMES/N/2//'
      aa=aa+'MCR_TABS/N/1//MCR_WIDTH/N/3//Where/C/30/PrelimExpr/C/200/WhileExpr/'
      aa += "C/200/NextRecs/N/6//RestRecs/L/Var/C/200/Prompt/C/200"
      fCreateDBF(aa)
      aa=cPrefix+'FMDATA/FORM_NO/C/5/RR/C/100/CC/C/100/EXPRESSION/C/200/DESC/C/40/'
      aa=aa+'PRT_NOT_E/L/NO_COMPRES/L/BOLD/L/ULINE/L/MAX_ROWS/N/2//ALT_COL/N/3//'
      aa=aa+'COND_ST/C/10/COND_END/L/CONDITION/C/200/MA_START/C/8/MA_STOP/C/8/'
      aa=aa+'MA_USE/C/8/MA_TIMES/N/2//SEL_USEFND/L/COND_CTR/N/3//PRELIM_EXP/C/254'
      fCreateDBF(aa)
      aa='BVFMFLDS/FIELD_NAME/C/10/FIELD_TYPE/C/1/FIELD_LEN/N/3//FIELD_DEC/N/3//'
      aa=aa+'DESC/C/40/FILENAME/C/8'
      fCreateDBF(aa)
      aa='BVFMFUNC/FUNCNAME/C/10/FOR_TYPE/C/1/P1_PROMPT/C/25/P1_TYPE/C/1/P1_LEN/'
      aa=aa+'N/3//P2_PROMPT/C/25/P2_TYPE/C/1/P2_LEN/N/3//P3_PROMPT/C/25/'
      aa=aa+'P3_TYPE/C/1/P3_LEN/N/3//DESC/C/40'
      fCreateDBF(aa)
      aa='BVFMOPS/OP_NAME/C/30/FOR_TYPE/C/1/OPERAND/C/5'
      fCreateDBF(aa)
      aa='BVFMSYS/USE_F2/L'
      fCreateDBF(aa)
   endi
   sel_fnd=.y.
   fill_in=space(254)
   cursel=select()
   set dele on
   if pcount()=0
      formx=''
      form_type=0
   endi
   if form_type=1
      m->single=.y.
   else
      m->single=.n.
      if form_type!=2.and.form_type!=3
         clos data
      endi
   endi
   if type('syscolor')='U'
      syscolor=.n.
      color_set=''
   endi
   stor 0 to wrow,wcol,currec
   set excl off
   sele 147
   fShare(cPrefix+'FM', "bvfm")
   if !file(cPrefix+'FM.NTX')
      vMessageOn("Indexing Main form file...")
      inde on form_no to (cPrefix+"fm")
      go top
      vMessageOff()
   else
      set inde to (cPrefix+"fm")
   endi
   sele 148
   fShare(cPrefix+'FMDATA', "bvfmdata")
   if !file(cPrefix+'FMDATA.NTX')
      vMessageOn("Indexing Secondary form file...")
      inde on form_no+str(val(rr),3)+str(val(cc),3)+Str(RecNo(), 5) to (cPrefix+"fmdata")
      vMessageOff()
   else
      set inde to (cPrefix+"fmdata")
   endi
   if syscolor
      INITIALIZE Color_Set to "bg, b/w"
      set colo to (color_set)
   endi
   SELECT BVFM
   if form_type=2
      seek formx
      if !found()
         SELECT BVFM
         use
         SELECT BVFMDATA
         use
         sele (cursel)
         retu(.n.)
      else
         do b__align
      endi
      SELECT BVFM
      use
      SELECT BVFMDATA
      use
      sele (cursel)
      retu(.y.)
   endi
   if form_type=3
      formx=trim(formx)
      max_forms=len(formx)/5
      vSave()
      iJunk(vWindow(max_forms+1,50,.y.,'CHOOSE FORMS TO PRINT'))
      prow=wrow
      pcol=wcol
      form_opt=1
      m->single=.y.
      do whil form_opt!=max_forms+1
         SELECT BVFM
         for x=1 to max_forms
            seek substr(formx,(x-1)*5+1,5)
            @ prow+x-1,pcol prom chr(64+x)+'.  '+name
         next
         @ prow+max_forms,pcol prom 'Q/uit'
         menu to form_opt
         if form_opt=0
            loop
         endi
         if form_opt<=max_forms
            if type('SEL_MAX')='N'
               for xx=1 to sel_max
                  aa=str(xx,1)
                  cxc=upper(substr(sel_areas,xx,1))
                  if val(cxc)=0
                     sele (asc(cxc)-64)
                  else
                     sele (val(cxc))
                  endi
                  bb=sel_seek&aa.
                  bb_chk=sel_chk&aa.
                  seek &bb.
                  if found()
                     sel_fnd=.y.
                     if type('SEL_END&AA.')='N'
                        sel__ctr=1
                        do whil sel__ctr<=sel_end&aa..and.&bb.=&bb_chk.
                           skip
                           sel__ctr=sel__ctr+1
                        endd
                        if &bb.!=&bb_chk.
                           seek &bb.
                        endi
                     endi
                  else
                     sel_fnd=.n.
                  endi
               next
               rele aa,bb,cxc
            endi
            SELECT BVFM
            seek substr(formx,(form_opt-1)*5+1,5)
            do b__fmi
            form_opt=form_opt+1
         endi
      endd
      SELECT BVFM
      use
      SELECT BVFMDATA
      use
      sele (cursel)
      vRestore()
      retu(.y.)
   endi
   if m->single
      seek formx
      if !found()
         SELECT BVFM
         use
         SELECT BVFMDATA
         use
         sele (cursel)
         retu(.n.)
      else
         do b__fmi
         sele (cursel)
         retu(.y.)
      endi
   endi
   clea
   @ 0,0 say 'Beckner Forms Generator v'+cVersion
   @ 1,0 say 'Copyright (c)1992 BecknerVision Inc . 800/548-6232'
   @ 2,0 to 22,79
   @ 3,1 to 19,12 doub
   @ 3,13 to 21,59 doub
   @ 3,60 to 21,78 doub
   @ 5,2 to 5,11
   @ 5,14 to 5,58
   @ 5,61 to 5,77
   vCenter(9,4,3,'OPTIONS')
   vCenter(46,4,14,'FORMS GENERATION INFORMATION')
   vCenter(18,4,61,'MEMO')
   @ 6,15 say 'Form code #/Where?'
   @ 7,15 say 'Form name ........'
   @ 8,15 say 'DBF prefix/codes .'
   @ 9,15 say 'DBF/NTX A ........'
   @ 10,15 say 'DBF/NTX B ........'
   @ 11,15 say 'DBF/NTX C ........'
   @ 12,15 say 'DBF/NTX D ........'
   @ 13,15 say 'DBF/NTX E ........'
   @ 14,15 say 'DBF/NTX F ........'
   @ 15,15 say 'DBF/NTX G ........'
   @ 16,15 say 'DBF/NTX H ........'
   @ 17,15 say 'Len/Sngl/Aln/Stg/+'
   @ 18,15 say 'Micro Adj Strt/stp'
   @ 19,15 say 'MA use/multiplier '
   @ 20,15 say 'Memo tabs/width   '
   @ 14,2 to 14,11
   @ 17,2 to 17,11
   flt_string=''
   flt_status=.n.
   @ 22,30 say 'FILTER OFF'
   @ 22,50 say 'Record #'
   if reccount()>0
      do b__dispf
   endi
   option=2
   do whil .y.
      SELECT BVFM
      if currec>0
         go currec
      endi
      @ 6,2 prom 'Delete    '
      @ 7,2 prom 'Get form  '
      @ 8,2 prom 'Add form  '
      @ 9,2 prom 'Edit form '
      @ 10,2 prom 'Variables '
      @ 11,2 prom '+/next    '
      @ 12,2 prom '-/prior   '
      @ 13,2 prom 'Filter    '
      @ 15,2 prom 'Reports   '
      @ 16,2 prom 'Maintenanc'
      @ 18,2 prom 'Quit      '
      oldopt=option
      menu to option
      if option=0
         option=oldopt
         loop
      endi
      DO CASE
      CASE Option=1
         DO b__fma
      CASE Option=2
         DO b__fmb
      CASE Option=3
         DO b__fmc
      CASE Option=4
         DO b__fmd
      CASE Option=5
         DO b__fme
      CASE Option=6
         DO b__fmf
      CASE Option=7
         DO b__fmg
      CASE Option=8
         DO b__fmh
      CASE Option=9
         DO b__fmi
      CASE Option=10
         DO b__fmj
      CASE option=11
         CLOSE ALL
         SET COLOR TO
         CLS
         sele (cursel)
         retu(.y.)
      ENDCASE
   endd
ENDFUNCTION

   STATIC proc b__fma
      if !vIsSure()
         retu
      endi
      fLockRec()
      dele
      unlock
      sele bvfmdata
      seek bvfm->form_no
      do whil bvfm->form_no=form_no.and.!eof()
         fLockRec()
         dele
         unlock
         skip
      endd
      SELECT bvfm
      SKIP
      IF eof()
         SKIP -1
      ENDIF
      do b__dispf
      retu

      STATIC proc b__fmb
         LOCAL nOption
         if reccount()=0
            Alert("* * *  WARNING  * * *;;No forms exist!;;Use the ADD option.")
            retu
         endi
         nOption := vPopWhen("Choose Form", "bvfm", vPWSet("bvfm", RecNo()), "RecNo()",;
         "Name+' '+Form_No", {1, 25, 23, 78})
         IF nOption!=0
            GOTO nOption
            do b__dispf
         ENDIF
         retu

         STATIC proc b__fmc
            save scre to wscreen
            @ 6,34 clea to 19,58
            @ 6,61 clea to 19,77
            fAddRecord()
            @ 6,34 get form_no pict '@! AA'
            @ 6,40 get where pict '@S15'
            @ 7,34 get name pict '@S22'
            @ 8,34 get dbf_prefix pict '@! AA'
            @ 8,37 get st_codes pict '@S6'
            @ 8,44 get en_codes pict '@S6'
            @ 9,34 get dbf_a pict '@!'
            @ 9,43 get ntx_a pict '@!'
            @ 10,34 get dbf_b pict '@!'
            @ 10,43 get ntx_b pict '@!'
            @ 11,34 get dbf_c pict '@!'
            @ 11,43 get ntx_c pict '@!'
            @ 12,34 get dbf_d pict '@!'
            @ 12,43 get ntx_d pict '@!'
            @ 13,34 get dbf_e pict '@!'
            @ 13,43 get ntx_e pict '@!'
            @ 14,34 get dbf_f pict '@!'
            @ 14,43 get ntx_f pict '@!'
            @ 15,34 get dbf_g pict '@!'
            @ 15,43 get ntx_g pict '@!'
            @ 16,34 get dbf_h pict '@!'
            @ 16,43 get ntx_h pict '@!'
            @ 17,34 get length
            @ 17,43 get single pict 'Y'
            @ 17,45 get alignment pict 'Y'
            @ 17,47 get stagger pict 'Y'
            @ 17,49 get adder
            @ 18,34 get ma_start
            @ 18,43 get ma_stop
            @ 19,34 get ma_use
            @ 19,43 get ma_times
            @ 20,34 get mcr_tabs
            @ 20,40 get mcr_width
            set key -1 to fmhelp
            read
            set key -1 to
            if empty(form_no)
               rest scre from wscreen
               dele
               unlock
               retu
            endi
            repl notes with memoedit(notes,6,61,19,77,.y.)
            currec=recno()
            cd=left(form_no,2)
            x=0
            do whil .y.
               x=x+1
               a=cd+strtran(str(x,3),' ','0')
               seek a
               if !found()
                  exit
               endi
            endd
            go currec
            repl form_no with a
            unlock
            sele bvfmdata
            do whil .y.
               iJunk(vWindow(17,72,.y.,'EXPRESSIONS'))
               fAddRecord()
               repl form_no with bvfm->form_no
               @ wrow,wcol say 'Description .......' get desc
               @ row()+1,wcol say 'Expression ........' get expression pict '@S50'
               @ row()+1,wcol say 'Row ...............' get rr pict '@KS40'
               @ row()+1,wcol say 'Column ............' get cc pict '@KS40'
               @ row()+1,wcol say 'Bold print (Y/N)? .' get bold pict 'Y'
               @ row()+1,wcol say 'Underline (Y/N)? ..' get uline pict 'Y'
               @ row()+1,wcol say 'No prt on empty? ..' get prt_not_e pict 'Y'
               @ row()+1,wcol say 'Compress w/ empty? ' get no_compress pict 'Y'
               @ row()+1,wcol say 'Maximum rows? .....' get max_rows
               @ row()+1,wcol say 'Alternate column # ' get alt_col
               @ row()+1,wcol say 'Preliminary expr ..' get prelim_exp pict '@S50'
               @ row()+1,wcol say 'Micro Adj start ...' get ma_start
               @ row()+1,wcol say 'Micro Adj stop ....' get ma_stop
               @ row()+1,wcol say 'Micro Adj useage ..' get ma_use
               @ row()+1,wcol say 'Micro Adj multiplr ' get ma_times
               @ row()+1,wcol say 'Condition expr ....' get condition pict '@S50'
               @ row()+1,wcol say 'Condition alias/end' get cond_st pict '@!'
               @ row(),col()+1 get cond_end pict 'Y'
               set key -1 to fmvarhelp
               read
               set key -1 to
               if empty(expression)
                  dele
                  exit
               endi
               unlock
            endd
            unlock
            sele bvfm
            rest scre from wscreen
            do b__dispf
            retu

            STATIC PROCEDURE b__fmd
               if currec=0
                  retu
               endi
               fLockRec()
               @ 6,40 get where pict '@S15'
               @ 7,34 get name pict '@KS22'
               @ 8,34 get dbf_prefix pict '@!K AA'
               @ 8,37 get st_codes pict '@KS6'
               @ 8,44 get en_codes pict '@KS6'
               @ 9,34 get dbf_a pict '@!K'
               @ 9,43 get ntx_a pict '@!K'
               @ 10,34 get dbf_b pict '@!K'
               @ 10,43 get ntx_b pict '@!K'
               @ 11,34 get dbf_c pict '@!K'
               @ 11,43 get ntx_c pict '@!K'
               @ 12,34 get dbf_d pict '@!K'
               @ 12,43 get ntx_d pict '@!K'
               @ 13,34 get dbf_e pict '@!K'
               @ 13,43 get ntx_e pict '@!K'
               @ 14,34 get dbf_f pict '@!K'
               @ 14,43 get ntx_f pict '@!K'
               @ 15,34 get dbf_g pict '@!K'
               @ 15,43 get ntx_g pict '@!K'
               @ 16,34 get dbf_h pict '@!K'
               @ 16,43 get ntx_h pict '@!K'
               @ 17,34 get length
               @ 17,43 get single pict 'Y'
               @ 17,45 get alignment pict 'Y'
               @ 17,47 get stagger pict 'Y'
               @ 17,49 get adder
               @ 18,34 get ma_start
               @ 18,43 get ma_stop
               @ 19,34 get ma_use
               @ 19,43 get ma_times
               @ 20,34 get mcr_tabs
               @ 20,40 get mcr_width
               set key -1 to fmhelp
               read
               set key -1 to
               repl notes with memoedit(notes,6,61,19,77,.y.)
               unlock
               do b__dispf
               retu

               STATIC PROCEDURE b__fme
                  LOCAL aRC
                  save scre to wscreen
                  iJunk(vWindow(5,10,.y.,'OPTIONS'))
                  @ wrow,wcol prom 'Display   '
                  @ row()+1,wcol prom 'Scan      '
                  @ row()+1,wcol prom 'Filters   '
                  @ row()+1,wcol prom 'Conditions'
                  @ row()+1,wcol prom 'Browse    '
                  opt=1
                  menu to opt
                  rest scre from wscreen
                  if opt=0
                     retu
                  endi
                  IF Opt=5
                     fBrowse()
   RETURN
               ENDIF
               IF Opt=4
                  vSave()
                  aRC := vWindow(6, 78, .y., "CONDITIONS")
                  @ aRC[1],  aRC[2] SAY "Preliminary ..." GET PrelimExpr PICTURE "@KS62"
                  @ Row()+1, aRC[2] SAY "Variables ....." GET Var PICTURE "@KS62"
                  @ Row()+1, aRC[2] SAY "Prompts ......." GET Prompt PICTURE "@KS62"
                  @ Row()+1, aRC[2] SAY "While ........." GET WhileExpr  PICTURE "@KS62"
                  @ Row()+1, aRC[2] SAY "Next Records .." GET NextRecs
                  @ Row()+1, aRC[2] SAY "Rest of file? ." GET RestRecs   PICTURE "Y"
                  fLockRec()
                  READ
                  UNLOCK
                  vRestore()
   RETURN
            ENDIF
            if opt=3
               save scre to wscreen
               iJunk(vWindow(8,78,.y.,'FILTERS & RELATIONSHIPS'))
               @ wrow,wcol say 'A. ' get flt_a pict '@KS50'
               @ row()+1,wcol say 'B. ' get flt_b pict '@KS50'
               @ row(),wcol+55 get rel_b pict '@K'
               @ row()+1,wcol say 'C. ' get flt_c pict '@KS50'
               @ row(),wcol+55 get rel_c pict '@K'
               @ row()+1,wcol say 'D. ' get flt_d pict '@KS50'
               @ row(),wcol+55 get rel_d pict '@K'
               @ row()+1,wcol say 'E. ' get flt_e pict '@KS50'
               @ row(),wcol+55 get rel_e pict '@K'
               @ row()+1,wcol say 'F. ' get flt_f pict '@KS50'
               @ row(),wcol+55 get rel_f pict '@K'
               @ row()+1,wcol say 'G. ' get flt_g pict '@KS50'
               @ row(),wcol+55 get rel_g pict '@K'
               @ row()+1,wcol say 'H. ' get flt_h pict '@KS50'
               @ row(),wcol+55 get rel_h pict '@K'
               fLockRec()
               read
               unlock
               rest scre from wscreen
               retu
            endi
            sele bvfmdata
            if opt=1
               seek bvfm->form_no
               if !found()
                  iJunk(vWindow(1,15,.y.,''))
                  @ wrow,wcol say 'No expressions'
                  vAnyKey()
                  rest scre from wscreen
                  retu
               endi
               stor 1 to line,page,opt
               iJunk(vWindow(15,78,.y.,'EXPRESSION DISPLAY'))
               save scre to xscreen
               start_rec=recno()
               do whil .y.
                  if line=1.and.eof()
                     @ wrow+line-1,wcol say '*** END OF FILE ***'
                  else
                     @ wrow+line-1,wcol say line pict '99)'
                     @ row(),wcol+5 say rr
                     @ row(),wcol+9 say cc
                     @ row(),wcol+14 say left(expression,20)
                     @ row(),wcol+35 say left(desc,20)
                     @ row(),wcol+56 say prt_not_e pict 'Y'
                     @ row(),wcol+58 say no_compres pict 'Y'
                     @ row(),wcol+60 say bold pict 'Y'
                     @ row(),wcol+62 say uline pict 'Y'
                     @ row(),wcol+64 say max_rows
                     @ row(),wcol+67 say alt_col
                     @ row(),wcol+71 say left(prelim_exp,7)
                  endi
                  line=line+1
                  skip
                  if !eof().and.bvfm->form_no=form_no.and.line!=16
                     loop
                  endi
                  do whil .y.
                     @ 24,0
                     @ 24,0 prom '+/next page'
                     @ 24,col()+3 prom 'Restart'
                     @ 24,col()+3 prom 'Quit'
                     menu to opt
                     if opt=3.or.opt=0
                        rest scre from wscreen
                        retu
                     endi
                     if opt=1
                        if line=16
                           page=page+1
                        else
                           pBeep()
                           go start_rec
                        endi
                        line=1
                        exit
                     endi
                     go start_rec
                     if page>1
                        page=page-1
                     endi
                     rest scre from xscreen
                     line=1
                     exit
                  endd
                  @ wrow,wcol clea to wrow+14,wcol+69
               endd
            endi
            seek bvfm->form_no
            save scre to wscreen
            iJunk(vWindow(17,62,.y.,'EXPRESSIONS'))
            @ wrow,wcol say 'Description .......'
            @ row()+1,wcol say 'Expression ........'
            @ row()+1,wcol say 'Row ...............'
            @ row()+1,wcol say 'Column ............'
            @ row()+1,wcol say 'No prt on empty? ..'
            @ row()+1,wcol say 'No add compress ln?'
            @ row()+1,wcol say 'Bold print (Y/N)? .'
            @ row()+1,wcol say 'Underline (Y/N)? ..'
            @ row()+1,wcol say 'Maximum rows? .....'
            @ row()+1,wcol say 'Alternate column # '
            @ row()+1,wcol say 'Preliminary Expr ..'
            @ row()+1,wcol say 'Micro Adj start ...'
            @ row()+1,wcol say 'Micro Adj stop ....'
            @ row()+1,wcol say 'Micro Adj useage ..'
            @ row()+1,wcol say 'Micro Adj multiplr '
            @ row()+1,wcol say 'Condition expr ....'
            @ row()+1,wcol say 'Condition alias/end'
            prow=wrow
            pcol=wcol+21
            curpol=1
            if !found()
               save scre to xscreen
               if syscolor
                  set colo to g+
               endi
               @ 24,0 say 'There are no expressions for this form.'
               if syscolor
                  set colo to (color_set)
               endi
               iJunk(vWindow(2,14,.y.,'CHOOSE ONE'))
               opt=1
               @ wrow,wcol prom 'Add expres'
               @ row()+1,wcol prom 'Quit      '
               menu to opt
               if opt!=1
                  rest scre from wscreen
                  retu
               endi
               rest scre from xscreen
               do b_addx
            endi
            do whil .y.
               @ prow,pcol say desc
               @ row()+1,pcol say left(expression,40)
               @ row()+1,pcol say rr
               @ row()+1,pcol say cc
               @ row()+1,pcol say prt_not_e pict 'Y'
               @ row()+1,pcol say no_compres pict 'Y'
               @ row()+1,pcol say bold pict 'Y'
               @ row()+1,pcol say uline pict 'Y'
               @ row()+1,pcol say max_rows
               @ row()+1,pcol say alt_col
               @ row()+1,pcol say left(prelim_exp,40)
               @ row()+1,pcol say ma_start
               @ row()+1,pcol say ma_stop
               @ row()+1,pcol say ma_use
               @ row()+1,pcol say ma_times
               @ row()+1,pcol say left(condition,40)
               @ row()+1,pcol say cond_st
               @ row(),col()+1 say cond_end pict 'Y'
               @ 24,0
               opt=4
               @ 24,0 prom 'Add'
               @ 24,col()+3 prom 'Delete'
               @ 24,col()+3 prom 'Edit'
               @ 24,col()+3 prom '+/next'
               @ 24,col()+3 prom '-/prior'
               @ 24,col()+3 prom 'Quit'
               @ 24,col()+2 prom 'Get'
               @ 24,col()+2 prom 'Browse'
               menu to opt
               if opt=6.or.opt=0
                  rest scre from wscreen
                  retu
               endi
               do case
               case opt=1
                  do b_addx
                  loop
               case opt=2
                  fLockRec()
                  dele
                  unlock
                  SKIP
                  IF bvfm->Form_No!=Form_No
                     SKIP -1
                  ENDIF
                  IF bvfm->Form_No!=Form_No
                     rest scre from wscreen
                     retu
                  endi
                  loop
               case opt=3
                  fLockRec()
                  @ prow,pcol get desc pict '@K'
                  @ row()+1,pcol get expression pict '@KS40'
                  @ row()+1,pcol get rr pict '@KS40'
                  @ row()+1,pcol get cc pict '@KS40'
                  @ row()+1,pcol get prt_not_e pict 'Y'
                  @ row()+1,pcol get no_compres pict 'Y'
                  @ row()+1,pcol get bold pict 'Y'
                  @ row()+1,pcol get uline pict 'Y'
                  @ row()+1,pcol get max_rows
                  @ row()+1,pcol get alt_col
                  @ row()+1,pcol get prelim_exp pict '@KS40'
                  @ row()+1,pcol get ma_start
                  @ row()+1,pcol get ma_stop
                  @ row()+1,pcol get ma_use
                  @ row()+1,pcol get ma_times
                  @ row()+1,pcol get condition pict '@KS40'
                  @ row()+1,pcol get cond_st pict '@!K'
                  @ row(),col()+1 get cond_end pict 'Y'
                  set key -1 to fmvarhelp
                  read
                  set key -1 to
                  unlock
                  loop
               case opt=4
                  skip
                  if eof().or.bvfm->form_no!=form_no
                     pBeep()
                     skip -1
                  endi
                  loop
               case opt=5
                  skip -1
                  if bof().or.bvfm->form_no!=form_no
                     pBeep()
                     skip
                  endi
               case opt=7
                  temp_rec=recno()
                  seek bvfm->form_no
                  coun to x whil bvfm->form_no=form_no
                  x=x+1
                  go temp_rec
                  stuph()
               CASE Opt=8
                  fBrowse()
               endc
            endd
            retu

            STATIC PROCEDURE b__fmf
               skip
               if eof()
                  go bott
                  pBeep()
               endi
               do b__dispf
               retu

               STATIC PROCEDURE b__fmg
                  skip -1
                  if bof()
                     go top
                     pBeep()
                  endi
                  do b__dispf
                  retu

                  STATIC PROCEDURE b__fmh
                     LOCAL bError
                     if flt_status
                        flt_status=.n.
                        @ 22,37 say 'OFF'
                        set filt to
                        retu
                     endi
                     flt_string=space(230)
                     save scre to wscreen
                     iJunk(vWindow(1,60,.y.,'ENTER FILTER STRING'))
                     @ wrow,wcol get flt_string pict '@S60'
                     read
                     if empty(flt_string)
                        pBeep()
                        rest scre from wscreen
                        retu
                     endi
                     flt_string=trim(flt_string)
                     bError := ErrorBlock({||Break(NIL)})
                     BEGIN SEQUENCE
                        set filt to &flt_string
                        go top
                     RECOVER
                        Alert("Invalid filter condition -- ignoring")
                        SET FILTER TO
                        RESTORE SCREEN FROM wScreen
                        ErrorBlock(bError)
   RETURN
                  END SEQUENCE
                  ErrorBlock(bError)
                  if eof()
                     pBeep()
                     @ 24,0 say 'No records match filter.  Reverting to FILTER OFF.  Press any key...'
                     inkey(60)
                     rest scre from wscreen
                     set filt to
                     flt_string=''
                     retu
                  endi
                  rest scre from wscreen
                  do b__dispf
                  flt_status=.y.
                  @ 22,37 say 'ON '
                  retu

                  STATIC PROCEDURE b__fmi
                     if m->single
                        opt=2
                     else
                        save scre to wscreen
                        iJunk(vWindow(4,25,.y.,'REPORTS'))
                        @ wrow,wcol prom 'A. Print Setup Grid      '
                        @ row()+1,wcol prom 'B. Print Forms           '
                        @ row()+1,wcol prom 'C. List Available Forms  '
                        @ row()+1,wcol prom 'D. Alignment Check       '
                        opt=2
                        menu to opt
                        rest scre from wscreen
                     endi
                     if !empty(bvfm->where)
                        oldwhere=set(24, trim(bvfm->where))
                     endi
                     do case
                     CASE Opt=4
                        DO b__Align
                     case opt=0
                        retu
                     case opt=1
                        ml=iif(bvfm->length=0,66,bvfm->length)
                        mw=80
                        iJunk(vWindow(2,30,.y.,'FORM SIZE'))
                        @ wrow,wcol say 'Form length' get ml pict '999'
                        @ row()+1,wcol say 'Form width ' get mw pict '999'
                        read
                        ml=ml-1
                        mw=mw-1
                        set cons off
                        set prin on
                        pSendCodes(bvfm->st_codes)
                        ?? 'THIS LINE BEGINS ON ROW 0 AT COLUMN 0.'
                        ? replicate('x',mw+1)
                        ? 'LINES COLUMNS->'
                        ? '  3'
                        if mw>99
                           ?? space(95),replicate('1',mw-99)
                        endi
                        xstr='  4  00000111111111122222222223333333333444444444455555555556666666666777777777788888888889999999999000000000011111111112222222222333333333344444444445555555555'
                        ? left(xstr,mw+1)
                        xstr='  5  '
                        for x=5 to mw
                           xstr=xstr+right(str(x,3),1)
                        next
                        ? xstr
                        xstr='.56789'
                        for x=10 to mw
                           xstr=xstr+iif(x%10=0,'0','.')
                        next
                        ? '  6',replicate('.',mw-3)
                        for x=7 to ml
                           ? str(x,3),xstr
                        next
                        pSendCodes(bvfm->en_codes)
                        ?? chr(13)
                        set cons on
                        set prin off
                        rest scre from wscreen
                        retu
                     case opt=2
                        m->cc:=1
                        if !m->single
                           do b__fmb
                           vSave(1, 20)
                           aRC := vWindow(1, 20, .y., "")
                           @ aRC[1], aRC[2] SAY "# Copies:" GET m->cc PICTURE "99"
                           READ
                           vRestore()
                           if alignment
                              do whil .y.
                                 iJunk(vWindow(3,15,.y.,'OPTIONS'))
                                 @ wrow,wcol prom 'Alignment      '
                                 @ row()+1,wcol prom 'Print          '
                                 @ row()+1,wcol prom 'Quit           '
                                 opt=1
                                 menu to opt
                                 if opt=1
                                    do b__align
                                    loop
                                 endi
                                 if opt=2
                                    exit
                                 endi
                                 rest scre from wscreen
                                 retu
                              endd
                           else
                              iJunk(vWindow(2,15,.y.,'OPTIONS'))
                              @ wrow,wcol prom 'Print          '
                              @ row()+1,wcol prom 'Quit           '
                              opt=1
                              menu to opt
                              if opt!=1
                                 rest scre from wscreen
                                 retu
                              endi
                           endi
                           rest scre from wscreen
                           IF !Empty(bvfm->Var)
                              vSave(20, 78)
                              aRC := vWindow(20, 78, .y., "Preliminary Information")
                              cTemp := Trim(bvfm->Var)
                              cTemp2 := Trim(bvfm->Prompt)
                              @ aRC[1]-1, 0 SAY ""
                              WHILE !Empty(cTemp)
                                 ccc := sParse(@cTemp, "/")
                                 bError := ErrorBlock({||Break(NIL)})
                                 BEGIN SEQUENCE
                                    &ccc := Eval({||&(ggg:=sParse(@cTemp, "//"))})
                                 RECOVER
                                    Alert("Invalid preliminary information:;;Variable:;"+;
                                    ccc+";;Default data:;"+ggg)
                                    ErrorBlock(bError)
                                    LOOP
                                 END SEQUENCE
                                 ErrorBlock(bError)
                                 @ Row()+1, aRC[2] SAY sParse(@cTemp2, "//") GET &ccc PICTURE "@S50"
                              ENDWHILE
                              READ
                              vRestore()
                           ENDIF
                           sele a
                           prfx=trim(bvfm->dbf_prefix)
                           iif(File(fExtNew(prfx+trim(bvfm->dbf_a), "dbf")),;
                  fShare(prfx+trim(bvfm->dbf_a)),)
   if !empty(bvfm->ntx_a)
      set inde to (prfx+trim(bvfm->ntx_a))
   endi
   if !empty(bvfm->dbf_b)
      sele b
      fShare(prfx+trim(bvfm->dbf_b))
      if !empty(bvfm->ntx_b)
         set inde to (prfx+trim(bvfm->ntx_b))
      endi
   endi
   if !empty(bvfm->dbf_c)
      sele c
      fShare(prfx+trim(bvfm->dbf_c))
      if !empty(bvfm->ntx_c)
         set inde to (prfx+trim(bvfm->ntx_c))
      endi
   endi
   if !empty(bvfm->dbf_d)
      sele d
      fShare(prfx+trim(bvfm->dbf_d))
      if !empty(bvfm->ntx_d)
         set inde to (prfx+trim(bvfm->ntx_d))
      endi
   endi
   if !empty(bvfm->dbf_e)
      sele e
      fShare(prfx+trim(bvfm->dbf_e))
      if !empty(bvfm->ntx_e)
         set inde to (prfx+trim(bvfm->ntx_e))
      endi
   endi
   if !empty(bvfm->dbf_f)
      sele f
      fShare(prfx+trim(bvfm->dbf_f))
      if !empty(bvfm->ntx_f)
         set inde to (prfx+trim(bvfm->ntx_f))
      endi
   endi
   if !empty(bvfm->dbf_g)
      sele g
      fShare(prfx+trim(bvfm->dbf_g))
      if !empty(bvfm->ntx_g)
         set inde to (prfx+trim(bvfm->ntx_g))
      endi
   endi
   if !empty(bvfm->dbf_h)
      sele h
      fShare(prfx+trim(bvfm->dbf_h))
      if !empty(bvfm->ntx_h)
         set inde to (prfx+trim(bvfm->ntx_h))
      endi
   endi
   if !empty(bvfm->flt_a)
      sele a
      WHILE LOOPING
         bError := ErrorBlock({||Break(NIL)})
         BEGIN SEQUENCE
            set filt to &(bvfm->flt_a)
            go top
         RECOVER
            nOption := Alert("Invalid filter condition ("+Alias()+"):;;"+;
            Trim(bvfm->Flt_A), {"Correct", "Ignore"})
            SET FILTER TO
            IF nOption=1
               LOCK ALIAS bvfm
               vSave(1, 78)
               aRC := vWindow(1, 78, .y., "ENTER CORRECT FILTER CONDITION")
               @ aRC[1], aRC[2] GET bvfm->Flt_A PICTURE "@S78"
               READ
               UNLOCK ALIAS bvfm
               vRestore()
               ErrorBlock(bError)
               LOOP
            ENDIF
         END SEQUENCE
         ErrorBlock(bError)
         EXIT
      ENDWHILE
   endi
   if !empty(bvfm->flt_b)
      sele b
      WHILE LOOPING
         bError := ErrorBlock({||Break(NIL)})
         BEGIN SEQUENCE
            set filt to &(bvfm->Flt_B)
            go top
         RECOVER
            nOption := Alert("Invalid filter condition ("+Alias()+"):;;"+;
            Trim(bvfm->Flt_B), {"Correct", "Ignore"})
            SET FILTER TO
            IF nOption=1
               LOCK ALIAS bvfm
               vSave(1, 78)
               aRC := vWindow(1, 78, .y., "ENTER CORRECT FILTER CONDITION")
               @ aRC[1], aRC[2] GET bvfm->Flt_B PICTURE "@S78"
               READ
               UNLOCK ALIAS bvfm
               vRestore()
               ErrorBlock(bError)
               LOOP
            ENDIF
         END SEQUENCE
         ErrorBlock(bError)
         EXIT
      ENDWHILE
   endi
   if !empty(bvfm->flt_c)
      sele c
      WHILE LOOPING
         bError := ErrorBlock({||Break(NIL)})
         BEGIN SEQUENCE
            set filt to &(bvfm->Flt_C)
            go top
         RECOVER
            nOption := Alert("Invalid filter condition ("+Alias()+"):;;"+;
            Trim(bvfm->Flt_C), {"Correct", "Ignore"})
            SET FILTER TO
            IF nOption=1
               LOCK ALIAS bvfm
               vSave(1, 78)
               aRC := vWindow(1, 78, .y., "ENTER CORRECT FILTER CONDITION")
               @ aRC[1], aRC[2] GET bvfm->Flt_C PICTURE "@S78"
               READ
               UNLOCK ALIAS bvfm
               vRestore()
               ErrorBlock(bError)
               LOOP
            ENDIF
         END SEQUENCE
         ErrorBlock(bError)
         EXIT
      ENDWHILE
   endi
   sele a
   if !empty(bvfm->rel_b)
      bError := ErrorBlock({||Break(NIL)})
      BEGIN SEQUENCE
         set rela addi to &(bvfm->rel_b) into b
         go top
      RECOVER
         nOption := Alert("Invalid relationship (B) -- Ignoring:;;"+;
         Trim(bvfm->Rel_B))
         SET RELATION TO
      END SEQUENCE
      ErrorBlock(bError)
   endi
   if !empty(bvfm->rel_c)
      bError := ErrorBlock({||Break(NIL)})
      BEGIN SEQUENCE
         set rela addi to &(bvfm->rel_C) into C
         go top
      RECOVER
         nOption := Alert("Invalid relationship (C) -- Ignoring:;;"+;
         Trim(bvfm->Rel_C))
         SET RELATION TO
      END SEQUENCE
      ErrorBlock(bError)
   endi
   if !empty(bvfm->rel_d)
      bError := ErrorBlock({||Break(NIL)})
      BEGIN SEQUENCE
         set rela addi to &(bvfm->rel_D) into D
         go top
      RECOVER
         nOption := Alert("Invalid relationship (D) -- Ignoring:;;"+;
         Trim(bvfm->Rel_D))
         SET RELATION TO
      END SEQUENCE
      ErrorBlock(bError)
   endi
   if !empty(bvfm->rel_e)
      bError := ErrorBlock({||Break(NIL)})
      BEGIN SEQUENCE
         set rela addi to &(bvfm->rel_E) into E
         go top
      RECOVER
         nOption := Alert("Invalid relationship (E) -- Ignoring:;;"+;
         Trim(bvfm->Rel_E))
         SET RELATION TO
      END SEQUENCE
      ErrorBlock(bError)
   endi
   if !empty(bvfm->rel_f)
      bError := ErrorBlock({||Break(NIL)})
      BEGIN SEQUENCE
         set rela addi to &(bvfm->rel_F) into F
         go top
      RECOVER
         nOption := Alert("Invalid relationship (F) -- Ignoring:;;"+;
         Trim(bvfm->Rel_F))
         SET RELATION TO
      END SEQUENCE
      ErrorBlock(bError)
   endi
   if !empty(bvfm->rel_g)
      bError := ErrorBlock({||Break(NIL)})
      BEGIN SEQUENCE
         set rela addi to &(bvfm->rel_G) into G
         go top
      RECOVER
         nOption := Alert("Invalid relationship (G) -- Ignoring:;;"+;
         Trim(bvfm->Rel_G))
         SET RELATION TO
      END SEQUENCE
      ErrorBlock(bError)
   endi
   if !empty(bvfm->rel_h)
      bError := ErrorBlock({||Break(NIL)})
      BEGIN SEQUENCE
         set rela addi to &(bvfm->rel_H) into H
         go top
      RECOVER
         nOption := Alert("Invalid relationship (H) -- Ignoring:;;"+;
         Trim(bvfm->Rel_H))
         SET RELATION TO
      END SEQUENCE
      ErrorBlock(bError)
   endi
   go top
endi
set devi to prin
set cons off
set prin on
IF !Empty(bvfm->PrelimExpr)
   WHILE LOOPING
      bError := ErrorBlock({||Break(NIL)})
      BEGIN SEQUENCE
         Eval({||&(bvfm->PrelimExpr)})
      RECOVER
         SET DEVICE TO Screen
         nOption := Alert("Invalid preliminary expression:;;"+;
         Trim(bvfm->Prelim_Expr), {"Correct", "Ignore"})
         IF nOption=1
            LOCK ALIAS bvfm
            vSave(1, 78)
            aRC := vWindow(1, 78, .y., "ENTER CORRECT PRELIMINARY EXPRESSION")
            @ aRC[1], aRC[2] GET bvfm->Prelim_Expr PICTURE "@S78"
            READ
            UNLOCK ALIAS bvfm
            vRestore()
            ErrorBlock(bError)
            SET DEVICE TO Printer
            LOOP
         ENDIF
      END SEQUENCE
      SET DEVICE TO Printer
      ErrorBlock(bError)
      EXIT
   ENDWHILE
ENDIF
if !bvfm->single
   pSendCodes(bvfm->ma_start)
   if val(bvfm->ma_use)!=0
      for x=1 to bvfm->ma_times
         pSendCodes(bvfm->ma_use)
      next
   endi
   pSendCodes(bvfm->ma_stop)
   pSendCodes(bvfm->st_codes)
endi
if type('long')='U'
   long=.n.
endi
rr_adder=0
c_lines=0
last_rr='-1'
maybe=.n.
AAAAA:=iif(Empty(bvfm->WhileExpr), ".y.", bvfm->WhileExpr)
do whil !eof() .and. &(aaaaa)
   iCount(0)
   WHILE iCount()<=m->cc
      if bvfm->single
         set devi to scre
         @ 24,0 say 'Load '+trim(left(bvfm->name,45))+'.  Press any key to print...'
         inkey(0)
         @ 24,0
         set devi to prin
         pSendCodes(bvfm->ma_start)
         if val(bvfm->ma_use)!=0
            for x=1 to bvfm->ma_times
               pSendCodes(bvfm->ma_use)
            next
         endi
         pSendCodes(bvfm->ma_stop)
         pSendCodes(bvfm->st_codes)
      endi
      setprc(0,0)
      SELECT BVFMDATA
      seek bvfm->form_no
      if !found()
         SELECT BVFM
         use
         SELECT BVFMDATA
         use
         sele a
         set devi to scre
         set cons on
         set prin off
         retu
      endi
      nCtr=0
      do whil !eof().and.bvfm->form_no=form_no
         if 'FILL_IN'$upper(expression)
            nctr=nctr+1
            a=ltrim(str(nctr))
            fill_in&a.=space(100)
            fill_d&a.=trim(sSetLength(desc, 28))+' '
            fill_d&a.=fill_d&a.+replicate('.',30-len(fill_d&a.))
         endi
         skip
      endd
      seek bvfm->form_no
      if nctr>0
         vSave()
         set devi to scre
         iJunk(vWindow(min(20,nctr),78,.y.,'Fill In Fields'))
         vSave()
         stor 0 to currctr,ndone
         do whil .y.
            currctr=currctr+1
            a=ltrim(str(currctr+ndone))
            @ wrow+currctr-1,wcol say fill_d&a. get fill_in&a. pict '@S45'
            if currctr=20.or.currctr=nctr
               read
               vRestore()
               if currctr=nctr
                  exit
               endi
               vSave()
               ndone=ndone+20
               nctr=nctr-20
               currctr=0
            endi
         endd
         nctr=nctr+ndone
         set devi to prin
         vRestore()
      endi
      currctr=0
      do whil !eof().and.bvfm->form_no=form_no
         rrr=trim(rr)
         ccc=trim(cc)
         if !empty(prelim_exp)
            WHILE LOOPING
               bError := ErrorBlock({||Break(NIL)})
               BEGIN SEQUENCE
                  Eval({||&(bvfmData->Prelim_Expr)})
               RECOVER
                  SET DEVICE TO Screen
                  nOption := Alert("Invalid preliminary expression:;;"+;
                  Trim(bvfmData->Prelim_Expr), {"Correct", "Ignore"})
                  IF nOption=1
                     LOCK ALIAS bvfmData
                     vSave(1, 78)
                     aRC := vWindow(1, 78, .y., "ENTER CORRECT PRELIMINARY EXPRESSION")
                     @ aRC[1], aRC[2] GET bvfmData->Prelim_Expr PICTURE "@S78"
                     READ
                     UNLOCK ALIAS bvfmData
                     vRestore()
                     ErrorBlock(bError)
                     SET DEVICE TO Printer
                     LOOP
                  ENDIF
                  SET DEVICE TO Printer
               END SEQUENCE
               ErrorBlock(bError)
               EXIT
            ENDWHILE
         endi
/* integrity check on expression, row, col */
                           WHILE LOOPING
                              bError := ErrorBlock({||Break(NIL)})
                              BEGIN SEQUENCE
                                 Eval({||&(bvfmData->RR)})
                              RECOVER
                                 SET DEVICE TO Screen
                                 nOption := Alert("Invalid row expression:;;"+;
                                 Trim(bvfmData->RR), {"Correct", "Ignore"})
                                 IF nOption=1
                                    LOCK ALIAS bvfmData
                                    vSave(1, 30)
                                    aRC := vWindow(1, 30, .y., "ENTER CORRECT ROW EXPRESSION")
                                    @ aRC[1], aRC[2] GET bvfmData->RR
                                    READ
                                    UNLOCK ALIAS bvfmData
                                    vRestore()
                                    ErrorBlock(bError)
                                    SET DEVICE TO Printer
                                    LOOP
                                 ENDIF
                                 SET DEVICE TO Printer
                              END SEQUENCE
                              ErrorBlock(bError)
                              RRR := Trim(bvfmData->RR)
                              EXIT
                           ENDWHILE
                           WHILE LOOPING
                              bError := ErrorBlock({||Break(NIL)})
                              BEGIN SEQUENCE
                                 Eval({||&(bvfmData->CC)})
                              RECOVER
                                 SET DEVICE TO Screen
                                 nOption := Alert("Invalid column expression:;;"+;
                                 Trim(bvfmData->CC), {"Correct", "Ignore"})
                                 IF nOption=1
                                    LOCK ALIAS bvfmData
                                    vSave(1, 30)
                                    aRC := vWindow(1, 30, .y., "ENTER CORRECT COLUMN EXPRESSION")
                                    @ aRC[1], aRC[2] GET bvfmData->CC
                                    READ
                                    UNLOCK ALIAS bvfmData
                                    vRestore()
                                    ErrorBlock(bError)
                                    SET DEVICE TO Printer
                                    LOOP
                                 ENDIF
                                 SET DEVICE TO Printer
                              END SEQUENCE
                              ErrorBlock(bError)
                              CCC := Trim(bvfmData->CC)
                              EXIT
                           ENDWHILE
                           WHILE LOOPING
                              bError := ErrorBlock({||Break(NIL)})
                              BEGIN SEQUENCE
                                 Eval({||&(bvfmData->Expression)})
                              RECOVER
                                 SET DEVICE TO Screen
                                 nOption := Alert("Invalid data expression:;;"+;
                                 Trim(bvfmData->Expression), {"Correct", "Ignore"})
                                 IF nOption=1
                                    LOCK ALIAS bvfmData
                                    vSave(1, 78)
                                    aRC := vWindow(1, 78, .y., "ENTER CORRECT EXPRESSION")
                                    @ aRC[1], aRC[2] GET bvfmData->Expression PICTURE "@S78"
                                    READ
                                    UNLOCK ALIAS bvfmData
                                    vRestore()
                                    ErrorBlock(bError)
                                    SET DEVICE TO Printer
                                    LOOP
                                 ENDIF
                                 SET DEVICE TO Printer
                              END SEQUENCE
                              ErrorBlock(bError)
                              EXIT
                           ENDWHILE
/* end check */
         if !empty(cond_st)
            m->cond_ctr=iif(cond_ctr=0,1,cond_ctr)
            st_no=recno()
            cond_sel=select(cond_st)
            sele (cond_sel)
            mcro=trim(bvfmdata->condition)
            IF (&MCRO.).and.((bvfmdata->sel_usefnd.and.sel_fnd).or.!bvfmdata->sel_usefnd)
               do whil &mcro.
                  SELECT BVFMDATA
                  go st_no
                  do whil .y.
                     exp=trim(expression)
                     if 'FILL_IN'$upper(exp)
                        currctr=currctr+1
                        a=ltrim(str(currctr))
                        if currctr>nctr
                           exp='""'
                        else
                           exp='trim(fill_in'+a+')'
                        endi
                     endi
                     ccc=trim(bvfmdata->cc)
                     if type('&exp.')='M'
                        ___width=bvfm->mcr_width
                        ___tab=bvfm->mcr_tabs
                        ___wrap=.y.
                        ___max=mlcount(&exp.,___width,___tab,___wrap)
                        ___lines=min(___max,bvfmdata->max_rows)
                        @ &rrr.,&ccc. say ''
                        pSendCodes(bvfmdata->ma_start)
                        if val(bvfmdata->ma_use)!=0
                           for x=1 to bvfmdata->ma_times
                              pSendCodes(bvfmdata->ma_use)
                           next
                        endi
                        pSendCodes(bvfmdata->ma_stop)
                        setprc(&rrr.,&ccc.)
                        for ___x=1 to ___lines
                           @ &rrr.+___x-1,&ccc. say memoline(&exp.,___width,___x,___tab,___wrap)
                           if ___x+bvfmdata->max_rows<=___max
                              @ &rrr.+___x-1,bvfmdata->alt_col say memoline(&exp.,___width,___x+bvfmdata->max_rows,___wrap)
                           endi
                        next
                        rele ___width,___tab,___wrap,___max,___x,___lines
                     else
                        @ &rrr.,&ccc. say ''
                        pSendCodes(bvfmdata->ma_start)
                        if val(bvfmdata->ma_use)!=0
                           for x=1 to bvfmdata->ma_times
                              pSendCodes(bvfmdata->ma_use)
                           next
                        endi
                        pSendCodes(bvfmdata->ma_stop)
                        setprc(&rrr.,&ccc.)
                        iif(!Empty(bvfmData->Prelim_Exp),;
                              Eval({||&(bvfmData->Prelim_Expr)}),)
                        @ &rrr.,&ccc. say &exp.
                     endi
                     if cond_end
                        exit
                     endi
                     skip
                  endd
                  sele (cond_sel)
                  skip
                  rrr=str(&rrr.+m->cond_ctr,3)
               endd
            ENDI
            SELECT BVFMDATA
            last_rr=rrr
            skip
            loop
         endi
         exp=trim(expression)
         if 'FILL_IN'$upper(exp)
            currctr=currctr+1
            a=ltrim(str(currctr))
            if currctr>nctr
               exp='""'
            else
               exp='trim(fill_in'+a+')'
            endi
            fill_in=trim(fill_in)
         endi
         if prt_not_e.and.empty(&exp.)
            if &last_rr.<&rrr.
               maybe=.y.
            endi
            last_rr=rrr
            skip
            if eof()
               loop
            endi
            if &last_rr.<&rrr..and.maybe
               c_lines=c_lines+1
            endi
            maybe=.n.
            loop
         endi
         if c_lines>0.and.no_compres
            if type('&exp.')='M'
               *The proper way of handling memo flds would be to put the following 2 values
               *in the bvfmdata file.  Maybe someday.
               ___width=bvfm->mcr_width
               ___tab=bvfm->mcr_tabs
               ___wrap=.y.
               ___max=mlcount(&exp.,___width,___tab,___wrap)
               @ &rrr.-c_lines,&ccc. say ''
               pSendCodes(bvfmdata->ma_start)
               if val(bvfmdata->ma_use)!=0
                  for x=1 to bvfmdata->ma_times
                     pSendCodes(bvfmdata->ma_use)
                  next
               endi
               pSendCodes(bvfmdata->ma_stop)
               setprc(&rrr.-c_lines,&ccc.)
               for ___x=1 to ___max
                  @ &rrr.-c_lines+___x-1,&ccc. say memoline(&exp.,___width,___x,___tab,___wrap)
               next
               rele ___width,___tab,___wrap,___max,___x
            else
               @ &rrr.-c_lines,&ccc. say ''
               pSendCodes(bvfmdata->ma_start)
               if val(bvfmdata->ma_use)!=0
                  for x=1 to bvfmdata->ma_times
                     pSendCodes(bvfmdata->ma_use)
                  next
               endi
               pSendCodes(bvfmdata->ma_stop)
               setprc(&rrr.-c_lines,&ccc.)
               @ &rrr.-c_lines,&ccc. say &exp.
            endi
         else
            c_lines=0
            if type('&exp.')='M'
               *The proper way of handling memo flds would be to put the following 2 values
               *in the bvfmdata file.  Maybe someday.
               ___width=bvfm->mcr_width
               ___tab=bvfm->mcr_tabs
               ___wrap=.y.
               ___max=mlcount(&exp.,___width,___tab,___wrap)
               @ &rrr.,&ccc. say ''
               pSendCodes(bvfmdata->ma_start)
               if val(bvfmdata->ma_use)!=0
                  for x=1 to bvfmdata->ma_times
                     pSendCodes(bvfmdata->ma_use)
                  next
               endi
               pSendCodes(bvfmdata->ma_stop)
               setprc(&rrr.,&ccc.)
               for ___x=1 to ___max
                  @ &rrr.+___x-1,&ccc. say memoline(&exp.,___width,___x,___tab,___wrap)
               next
               rele ___width,___tab,___wrap,___max,___x
            else
               @ &rrr.,&ccc. say ''
               pSendCodes(bvfmdata->ma_start)
               if val(bvfmdata->ma_use)!=0
                  for x=1 to bvfmdata->ma_times
                     pSendCodes(bvfmdata->ma_use)
                  next
               endi
               pSendCodes(bvfmdata->ma_stop)
               setprc(&rrr.,&ccc.)
               @ &rrr.,&ccc. say &(exp)
            endi
         endi
         last_rr=rrr
         skip
      endd
      set prin on
      @ bvfm->length-1,0 say ' '
      ?
      if bvfm->stagger
         if long
            ?
            long=.n.
         else
            long=.y.
         endi
      endi
      sele a
      if m->single
         set prin on
         pSendCodes(bvfm->en_codes)
         set devi to scre
         set cons on
         set prin off
         SELECT BVFM
         if form_type=3
            retu
         endi
         use
         SELECT BVFMDATA
         use
         sele a
         retu
      endi
   ENDWHILE
   skip
endd

pSendCodes(bvfm->en_codes)
set devi to scre
set cons on
set prin off
FOR i := 1 to 10
   SELECT (i)
   CLOSE
NEXT
SELECT 1
retu
case opt=3
   set cons off
   repo form bvfm to prin
   set cons on
   retu
endc
retu

STATIC PROCEDURE b__fmj
   save scre to wscreen
   iJunk(vWindow(13,25,.y.,'MAINTENANCE'))
   @ wrow,wcol prom 'A. Enter Row/Column data '
   @ row()+1,wcol prom 'B. Variables from DBF    '
   @ row()+1,wcol prom 'C. Set Column Transform  '
   @ row()+1,wcol prom 'D. Mass Row/Col change   '
   @ row()+1,wcol prom 'E. Get current fields-F2 '
   @ row()+1,wcol prom 'F. Enter descriptions-F2 '
   @ row()+1,wcol prom 'G. Duplicate current form'
   @ row()+1,wcol prom 'H. Expression Count      '
   @ row()+1,wcol prom 'I. Fast New Expressions  '
   @ row()+1,wcol prom 'J. Increment Expr Group  '
   @ row()+1,wcol prom 'K. Change Form #         '
   @ row()+1,wcol prom 'L. Field List            '
   @ row()+1,wcol prom 'M. Fields from Table     '
   opt=1
   menu to opt
   rest scre from wscreen
   if opt=0
      retu
   endi
   do case
   CASE Opt=13
      AddTable()
   CASE Opt=12
      FldLst()
   CASE Opt=11
      MaintK()
   CASE Opt=10
      MaintJ()
   CASE Opt=9
      MaintI()
   CASE Opt=8
      SELECT bvfmdata
      SEEK bvfm->Form_No
      COUNT to x while bvfm->Form_No=Form_No
      SELECT bvfm
      vSave(1, 40)
      aRC := vWindow(1, 40, .y., "")
      @ aRC[1], aRC[2] SAY "Expression count ..."
      @ Row(), Col()+1 SAY x PICTURE "9,999"
      Inkey(0)
      vRestore()
      rest scre from wscreen
      retu
   case opt=1
      iJunk(vWindow(4,70,.y.,'FORMS INFORMATION'))
      SELECT BVFM
      fLockRec()
      @ wrow,wcol say 'Number of lines per form ...' get length
      @ row()+1,wcol say 'Use staggered print (Y/N)? .' get stagger pict 'Y'
      @ row()+1,wcol say 'Adder ......................' get adder
      @ row()+1,wcol say 'Single sheet load (Y/N)? ...' get single pict 'Y'
      read
      unlock
      iJunk(vWindow(3,70,.y.,'ENTER ROW/COLUMN DATA'))
      SELECT BVFMDATA
      set orde to 0
      loca for bvfm->form_no=form_no
      SET KEY K_F2 to SetGrpRC
      do whil !eof().and.bvfm->form_no=form_no
         @ wrow,wcol say 'Description: '+desc
         @ row()+1,wcol+50 say '(-1) to delete'
         @ row(),wcol say 'Row .......' get rr PICT '@KS40'
         @ row()+1,wcol say 'Column ....' get cc pict '@KS40'
         fLockRec()
         read
         IF LastKey()=K_ESC
            SET KEY K_F2 to
            UNLOCK
            EXIT
         ENDIF
         if val(rr)=-1
            dele
         endi
         unlock
         cont
      endd
      SET KEY K_F2 to
      set orde to 1
      rest scre from wscreen
      retu
   case opt=2
      iJunk(vWindow(3,50,.y.,'DBF TO VARIABLE'))
      filename=left(bvfm->form_no,2)+'ACCT  '
      del_before=.n.
      prefix='a  '
      @ wrow,wcol say 'Enter filename, without extension ...' get filename pict '@!K' vali file(trim(filename)+'.dbf')
      @ row()+1,wcol say 'Delete old data first (Y/N)? ........' get del_before pict 'Y'
      @ row()+1,wcol say 'Variable prefix (A-J,1-255) .........' get prefix vali upper(left(prefix,1))$'ABCDEFGHIJ'.or.(val(prefix)>0.and.val(prefix)<256)
      read
      SELECT BVFMDATA
      if del_before
         fLockFile()
         dele all for form_no=bvfm->form_no
         unlock
      endi
      sele 250
      fShare(filename)
      copy stru exte to x
      use x excl
      @ 24,15 say reccount()
      do whil !eof()
         @ 24,0 say recno() pict '999,999'
         SELECT BVFMDATA
         fAddRecord()
         repl form_no with bvfm->form_no
         if 250->field_type='L'
            repl desc with '"X" if '+250->field_name,expression with 'iif('+trim(prefix)+'->'+trim(250->field_name)+',"X","")'
         else
            repl desc with 250->field_name+250->field_type+' '+str(250->field_len,3)+' '+str(250->field_dec,3),expression with trim(prefix)+'->'+250->field_name
         endi
         unlock
         sele 250
         skip
      endd
      use
      eras x.dbf
      SELECT BVFM
      rest scre from wscreen
   case opt=3
      iJunk(vWindow(2,40,.y.,'Column Transform'))
      cl=0
      tr='9999.99             '
      @ wrow,wcol say 'Column to transform ....' get cl pict '999'
      @ row()+1,wcol say 'Transform picture ......' get tr pict '@K'
      read
      tr=trim(tr)
      if !empty(tr)
         SELECT BVFMDATA
         seek bvfm->form_no
         do whil !eof().and.bvfm->form_no=form_no
            if val(cc)=cl
               fLockRec()
               repl expression with 'transform('+trim(expression)+',"'+tr+'")'
               unlock
            endi
            skip
         endd
      endi
      SELECT BVFM
      rest scre from wscreen
   case opt=4
      iJunk(vWindow(4,40,.y.,'MASS ROW/COL CHANGE'))
      stor 0 to rrch,ccch,rratio1,rratio2,cratio1,cratio2
      @ wrow,wcol say 'Row change (+/-) ...' get rrch pict '999'
      @ row()+1,wcol say 'Col change (+/-) ...' get ccch pict '999'
      @ row()+1,wcol say 'Row ratio change ...' get rratio1 pict '999.999'
      @ row(),col()+1 get rratio2 pict '999.999'
      @ row()+1,wcol say 'Column ratio change ' get cratio1 pict '999.999'
      @ row(),col()+1 get cratio2 pict '999.999'
      read
      SELECT BVFMDATA
      set orde to 0
      loca for bvfm->form_no=form_no
      do whil !eof().and.bvfm->form_no=form_no
         fLockRec()
         repl rr with str(val(rr)+rrch,3),cc with str(val(cc)+ccch,3)
         if rratio2>0
            repl rr with ltrim(str(round(val(rr)*rratio1/rratio2,0)))
         endi
         if cratio2>0
            repl cc with ltrim(str(round(val(cc)*cratio1/cratio2,0)))
         endi
         unlock
         cont
      endd
      set orde to 1
      SELECT BVFM
      rest scre from wscreen
   case opt=5
      sele 200
      zap_em=.n.
      @ 24,0 say 'Zap current data (Y/N)?' get zap_em pict 'Y'
      read
      @ 24,0
      fNoShare('bvfmflds')
      if zap_em
         if !vIsSure()
            use
            SELECT BVFM
            rest scre from wscreen
            retu
         endi
         zap
      endi
      inde on field_name to bvfmflds
      set uniq on
      inde on filename to bvfmfile
      set uniq off
      set inde to bvfmflds,bvfmfile
      for x=1 to 8
         a=chr(64+x)
         nm=trim(bvfm->dbf_prefix)+trim(bvfm->dbf_&a.)
         if file(nm+'.dbf')
            sele 0
            fShare(nm)
            copy stru exte to x
            use
            sele 200
            appe from x
            eras x.dbf
            repl filename with nm for empty(filename)
         endi
      next
      repl all desc with field_name
      use
      SELECT BVFM
      rest scre from wscreen
   case opt=6
      sele 200
      fShare('bvfmflds')
      set inde to bvfmflds
      iJunk(vWindow(3,60,.y.,'DESCRIPTIONS'))
      go top
      do whil !eof()
         @ wrow,wcol say 'Filename .......... '+filename
         @ row()+1,wcol say 'Field name ........ '+field_name
         @ row()+1,wcol say 'Description .......' get desc pict '@K'
         fLockRec()
         read
         unlock
         skip
      endd
      use
      SELECT BVFM
      rest scre from wscreen
   case opt=7
      old_form=form_no
      cd=left(form_no,2)
      x=0
      do whil .y.
         x=x+1
         a=cd+strtran(str(x,3),' ','0')
         seek a
         if !found()
            exit
         endi
      endd
      go currec
      copy next 1 to bvtemp
      fLockFile()
      appe from bvtemp
      unlock
      go reccount()
      fLockRec()
      repl form_no with a
      unlock
      SELECT BVFMDATA
      seek old_form
      if found()
         copy to bvtemp whil form_no=old_form
         startrec=reccount()+1
         set orde to 0
         fLockFile()
         appe from bvtemp
         go startrec
         rele startrec
         repl rest form_no with a
         unlock
         set orde to 1
      endi
      SELECT BVFM
      go currec
      @ 24,0
      @ 24,0 say 'Copied form #'+form_no+' to #'+a
      inkey(15)
      @ 24,0
   endc
   retu

   STATIC PROCEDURE b_addx
      fAddRecord()
      repl form_no with bvfm->form_no
      @ prow,pcol get desc
      @ row()+1,pcol get expression pict '@S40'
      @ row()+1,pcol get rr pict '@KS40'
      @ row()+1,pcol get cc pict '@KS40'
      @ row()+1,pcol get prt_not_e pict 'Y'
      @ row()+1,pcol get no_compres pict 'Y'
      @ row()+1,pcol get bold pict 'Y'
      @ row()+1,pcol get uline pict 'Y'
      @ row()+1,pcol get max_rows
      @ row()+1,pcol get alt_col
      @ row()+1,pcol get prelim_exp pict '@KS40'
      @ row()+1,pcol get ma_start
      @ row()+1,pcol get ma_stop
      @ row()+1,pcol get ma_use
      @ row()+1,pcol get ma_times
      @ row()+1,pcol get condition pict '@KS40'
      @ row()+1,pcol get cond_st pict '@!K'
      @ row(),col()+1 get cond_end pict 'Y'
      set key -1 to fmvarhelp
      read
      set key -1 to
      if empty(expression)
         pBeep()
         dele
         skip -1
      endi
      unlock
      retu

      STATIC PROCEDURE b__align
         set devi to prin
         set cons off
         set prin on
         setprc(0,0)
         sele bvfmdata
         seek bvfm->form_no
         do whil !eof().and.bvfm->form_no=form_no
            rrr=rr
            ccc=cc
            @ &rrr.,&ccc. say 'fld'
            skip
         endd
         sele bvfm
         @ length-1,0 say ''
         ?
         if type('long')='U'
            long=.n.
         endi
         if stagger
            if long
               ?
               long=.n.
            else
               long=.y.
            endi
         endi
         set devi to scre
         set cons on
         set prin off
         retu

         STATIC PROCEDURE b__dispf
            currec=recno()
            @ 6,34 clea to 19,58
            @ 6,61 clea to 19,77
            @ 6,34 say form_no
            @ 6,40 say left(where,15)
            @ 7,34 say left(name,22)
            @ 8,34 say dbf_prefix
            @ 8,37 say Left(st_codes, 6)
            @ 8,44 say Left(en_codes, 6)
            @ 9,34 say dbf_a
            @ 9,43 say ntx_a
            @ 10,34 say dbf_b
            @ 10,43 say ntx_b
            @ 11,34 say dbf_c
            @ 11,43 say ntx_c
            @ 12,34 say dbf_d
            @ 12,43 say ntx_d
            @ 13,34 say dbf_e
            @ 13,43 say ntx_e
            @ 14,34 say dbf_f
            @ 14,43 say ntx_f
            @ 15,34 say dbf_g
            @ 15,43 say ntx_g
            @ 16,34 say dbf_h
            @ 16,43 say ntx_h
            @ 17,34 say length
            @ 17,43 say single pict 'Y'
            @ 17,45 say alignment pict 'Y'
            @ 17,47 say stagger pict 'Y'
            @ 17,49 say adder
            @ 18,34 say ma_start
            @ 18,43 say ma_stop
            @ 19,34 say ma_use
            @ 19,43 say ma_times
            @ 20,34 say mcr_tabs
            @ 20,40 say mcr_width
            set key -1 to fmhelp
            read
            set key -1 to
            memoedit(notes,6,61,19,77,.n.,.y.)
            @ 22,58 say currec pict '9999'
            retu

            STATIC PROCEDURE fmhelp
               priv fld,ctr,cursel
               cursel=select()
               fld=readvar()
               save scre to zscreen
               do case
               case fld$'FORM_NOxDBF_PREFIXxCD'
                  priv choice[5]
                  choice[1]='Other system                          '
                  choice[2]='Beckner Premium Finance System II     '
                  choice[3]='BecknerVision Agency Management System'
                  choice[4]='BecknerVision Mini-Warehouse System   '
                  choice[5]='BecknerVision Consumer Loan System    '
                  @ 9,38 clea to 15,79
                  @ 9,38 to 15,79 doub
                  opt=achoice(10,39,14,78,choice)
                  rest scre from zscreen
                  if opt>0
                     repl &fld. with substr('  BPGAMWCL',(opt-1)*2+1,2)
                  endi
                  retu
               case left(fld,3)='DBF'
                  sele 0
                  fShare('bvdeffn')
                  priv choice[reccount()+1]
                  choice[1]='Other database file name                '
                  do whil !eof()
                     choice[recno()+1]=descrip
                     skip
                  endd
                  @ 6,38 clea to 17,79
                  @ 6,38 to 17,79 doub
                  opt=achoice(7,39,16,78,choice)
                  rest scre from zscreen
                  if opt>1
                     go opt-1
                     repl bvfm->&fld. with filename
                  endi
                  use
                  sele (cursel)
                  retu
               case fld='EXPRESSION'
                  sele 0
                  fShare('bvdefine')
                  priv choice[reccount()+1]
                  choice[1]='Other database expression               '
                  do whil !eof()
                     choice[recno()+1]=descrip
                     skip
                  endd
                  @ 6,38 clea to 17,79
                  @ 6,38 to 17,79 doub
                  opt=achoice(7,39,16,78,choice)
                  rest scre from zscreen
                  if opt>1
                     go opt-1
                     repl bvfmdata->expression with fieldname,bvfmdata->desc with descrip
                  endi
                  use
                  sele (cursel)
                  retu
               endc
               retu

               STATIC PROCEDURE fmvarhelp
                  LOCAL GetList := {}
                  priv option,temp_rec,ctr,buffer,a,x
                  @ 24,0
                  option=2
                  @ 24,0 prom 'C/opy'
                  @ 24,col()+2 prom 'F/ield list'
                  @ 24,col()+2 prom 'I/mport text'
                  @ 24,col()+2 prom 'A/bort'
                  menu to option
                  @ 24,0
                  if option=0.or.option=4
                     retu
                  endi
                  if option=1
                     temp_rec=recno()
                     seek bvfm->form_no
                     coun to x whil bvfm->form_no=form_no
                     if x=1
                        retu
                     endi
                     x=x+1
                     sele bvfm
                     priv choice[x],flds[fcount()]
                     sele bvfmdata
                     seek bvfm->form_no
                     ctr=1
                     do whil bvfm->form_no=form_no
                        choice[ctr]=desc
                        skip
                        ctr=ctr+1
                     endd
                     choice[x]='ABORT'
                     buffer=savescreen(6,38,19,79)
                     @ 6,38 to 19,79 doub
                     option=achoice(7,39,18,78,choice)
                     restscreen(6,38,19,79,buffer)
                     if option>0.and.option<x
                        seek bvfm->form_no
                        if option>1
                           a=str(option-1,3)
                           skip &a.
                        endi
                        for x=1 to fcount()
                           a=field(x)
                           flds[x]=&a.
                        next
                        go temp_rec
                        for x=1 to fcount()
                           a=field(x)
                           repl &a. with flds[x]
                        next
                     endi
                     go temp_rec
                     retu
                  endi
                  if option=3
                     vSave(1, 50)
                     aRC := vWindow(2, 50, .y., "Text Filename/Start Row #")
                     cText := Space(50)
                     nStart := 0
                     @ aRC[1],  aRC[2] GET cText PICTURE "@!"
                     @ Row()+1, aRC[2] GET nStart PICTURE "999"
                     READ
                     vRestore()
                     IF File(cText)
                        nHandle := fOpen(cText)
                        WHILE !feof(nHandle)
                           IF Empty(cLine := fReadLine(nHandle)) .or. Chr(26)$cLine
                              nStart++
                              LOOP
                           ENDIF
                           ADDRECORD ALIAS bvfmData
                           bvfmData->Form_No    := bvfm->Form_No
                           bvfmData->Expression := '"'+cLine+'"'
                           bvfmData->Desc       := Left(bvfmData->Expression, 10)
                           bvfmData->rr         := Str(nStart++, 3)
                           bvfmData->cc         := "0"
                        ENDWHILE
                        fClose(nHandle)
                     ENDIF
                     retu
                  endi
                  IF Option=2
                     FldLst()
                  ENDIF
RETURN

               static func fm_close
                  priv x
                  for x=200 to 210
                     sele (x)
                     use
                  next
                  sele bvfmdata
                  retu .y.

                  STATIC func stuph
                     LOCAL Option, nCurRec := RecNo()
                     priv choice[x]
                     seek bvfm->form_no
                     ctr=1
                     do whil bvfm->form_no=form_no
                        choice[ctr]=desc
                        skip
                        ctr=ctr+1
                     endd
                     choice[x]='ABORT'
                     buffer=savescreen(6,38,19,79)
                     @ 6,38 to 19,79 doub
                     @ 7,39 clea to 18,78
                     option=achoice(7,39,18,78,choice)
                     restscreen(6,38,19,79,buffer)
                     if option>0.and.option<x
                        seek bvfm->form_no
                        skip Option-1
                     ELSE
                        GOTO nCurRec
                     endi
                  ENDFUNCTION

                     STATIC FUNCTION MaintI()
                        LOCAL GetList := {}, aRC, nTemp, cTemp
                        vSave(5, 78)
                        vMessageOn("Initializing...")
                        SELECT BVFMDATA
                        SEEK bvfm->Form_No
                        IF Found()
                           WHILE !EOF() .and. Form_No=bvfm->Form_No
                              nTemp := RecNo()
                              SKIP
                           ENDWHILE
                           GOTO nTemp
                        ENDIF
                        vMessageOff()
                        WHILE LOOPING
                           aRC := vWindow(5, 78, .y., "New Expressions")
                           @ aRC[1],  aRC[2] SAY "Last Description .... "
                           DevOut(bvfmData->Desc)
                           @ Row()+1, aRC[2] SAY "Last Expression ..... "
                           DevOut(bvfmData->Expression)
                           cTemp := bvfmData->Desc
                           ADDRECORD
                           bvfmData->Desc       := cTemp
                           bvfmData->Expression := "Fill_In"
                           @ Row()+2, aRC[2] SAY "New Description ....." GET bvfmData->Desc;
                           PICTURE "@K"
                           @ Row()+1, aRC[2] SAY "New Expression ......" GET bvfmData->Expression;
                           PICTURE "@K"
                           READ
                           IF Empty(bvfmData->Desc) .or. LastKey()=K_ESC
                              EXIT
                           ENDIF
                           bvfmData->Form_No := bvfm->Form_No
                           UNLOCK
                        ENDWHILE
                        DELETE
                        UNLOCK
                        SELECT bvfm
                        vRestore()
                     ENDFUNCTION

                     STATIC FUNCTION MaintJ()
                        LOCAL GetList := {}, aRC, nStart, nEnd, nCurrent := 1, nLast := 1
                        LOCAL cPrelim := Space(500), aData := {}, l1stRec
                        LOCAL nPosDesc := bvfmData->(FieldPos("Desc"))
                        LOCAL nPosPrelim := bvfmData->(FieldPos("Prelim_Exp"))
                        vSave()
                        nStart := vPopWhen("Group START", "bvfmData", , "RecNo()", "Desc",;
                        , , , , {|| Form_No=bvfm->Form_No})
                        IF nStart=0
      RETURN NIL
                     ENDIF
                     nEnd := vPopWhen("Group END", "bvfmData", , "RecNo()", "Desc",;
                     , , , , {|| Form_No=bvfm->Form_No})
                     IF nEnd=0
      RETURN NIL
                  ENDIF
                  aRC := vWindow(3, 78, .y., "Adding New Expression Groups")
                  @ aRC[1],  aRC[2] SAY "Current ......" GET nCurrent PICTURE "99999"
                  @ Row()+1, aRC[2] SAY "Last ........." GET nLast PICTURE "99999"
                  @ Row()+1, aRC[2] SAY "Prelim Expr .." GET cPrelim PICTURE "@S50"
                  READ
                  vMessageOn("Creating New Groups...")
                  SELECT bvfmData
                  GOTO nEnd
                  SKIP
                  nEnd := RecNo()
                  GOTO nStart
                  WHILE nEnd!=RecNo() .and. !EOF()
                     aAdd(aData, aFromRec())
                     SKIP
                  ENDWHILE
                  WHILE nLast>=++nCurrent
                     l1stRec := .y.
      aEval(aData, {|a| fAddRecord(),           /* Add a new record        */;
            iif(l1stRec, a[nPosPrelim] := cPrelim, ), /* Set Prelim_Exp    */;
                     l1stRec := .n.,;
            a[nPosDesc] := StrTran(a[nPosDesc], /* Insert new #            */;
                           "#"+sMake(nCurrent-1),;
                           "#"+sMake(nCurrent)),;
            aToRec(a),                          /* Put data into record    */;
            dbUnlock()})                        /* unlock record           */
                        ENDWHILE
                        vMessageOff()
                        vRestore()
                     ENDFUNCTION

                     STATIC FUNCTION FldLst()
   /* Field List - Simple */
                     LOCAL aRC, GetList := {}, nCurSel := Select(), cFile := Space(64)
                     LOCAL aTemp := {}
                     vSave(1, 78)
                     aRC := vWindow(1, 64, .y., "ENTER FILENAME")
                     @ aRC[1],  aRC[2] GET cFile
                     READ
                     cFile := fExtNew(Trim(cFile), "DBF")
                     IF !File(cFile)
                        Alert("File "+cFile+";;NOT FOUND")
      RETURN NIL
                  ENDIF
                  USE (cFile) NEW READONLY SHARED ALIAS ToList
                  aTemp := dbStruct()
                  aEval(aTemp, {|a, n| aTemp[n] := a[DBS_NAME]+" "+a[DBS_TYPE]+" "+;
                  Str(a[DBS_LEN], 3)+" "+iif(a[DBS_TYPE]="N",;
                  Str(a[DBS_DEC], 3), "")})
                  aPickList(aTemp)
                  CLOSE
                  SELECT (nCurSel)
               ENDFUNCTION

               STATIC FUNCTION MaintK()
                  LOCAL cNewNumber := bvfm->(Form_No), aRC, GetList := {}, nCurRec := RecNo()
                  vSave(1, 30)
                  aRC := vWindow(1, 30, .y., "")
                  @ aRC[1],  aRC[2] SAY "New Form #" GET cNewNumber PICTURE "@K! AA999"
                  READ
                  vRestore()
                  SEEK cNewNumber ALIAS bvfm
                  IF Found()
                     GOTO nCurRec
                     Alert("Form #"+cNewNumber+" already exists;;NO CHANGES MADE")
      RETURN NIL
               ENDIF
               GOTO nCurRec
               vMessageOn("Changing Form #"+bvfm->Form_No+" to #"+cNewNumber)
               SELECT bvfmData
               SEEK bvfm->Form_No
               WHILE Found()
                  LOCK ALIAS bvfmData
                  bvfmData->Form_No := cNewNumber
                  UNLOCK ALIAS bvfmData
                  SEEK bvfm->Form_No
               ENDWHILE
               SELECT bvfm
               LOCK ALIAS bvfm
               bvfm->Form_No := cNewNumber
               UNLOCK ALIAS bvfm
               vMessageOff()
               DO b__DispF
            ENDFUNCTION

            STATIC FUNCTION SetGrpRC()
               LOCAL GetList := {}, aRC, nStart, nEnd, nCurrent := 1, nLast := 1
               LOCAL aData := {}, nPosDesc := bvfmData->(FieldPos("Desc")), nStartRow
               LOCAL nCurRec := RecNo(), nIncrement := 1, nAdder
               vSave()
               nStart := vPopWhen("Group START", "bvfmData", , "RecNo()", "Desc",;
               , , , , {|| Form_No=bvfm->Form_No})
               IF nStart=0
                  GOTO nCurRec
      RETURN NIL
            ENDIF
            nEnd := vPopWhen("Group END", "bvfmData", , "RecNo()", "Desc",;
            , , , , {|| Form_No=bvfm->Form_No})
            IF nEnd=0
               GOTO nCurRec
      RETURN NIL
         ENDIF
         aRC := vWindow(3, 78, .y., "Adding New Expression Groups")
         @ aRC[1],  aRC[2] SAY "Current ......" GET nCurrent PICTURE "99999"
         @ Row()+1, aRC[2] SAY "Last ........." GET nLast PICTURE "99999"
         @ Row()+1, aRC[2] SAY "Increment ...." GET nIncrement PICTURE "99999"
         READ
         nAdder := nIncrement
         vMessageOn("Modifying Groups...")
         GOTO nEnd
         SKIP
         nEnd := RecNo()
         GOTO nStart
         WHILE nEnd!=RecNo() .and. !EOF()
            aAdd(aData, {bvfmData->RR, bvfmData->CC})
            SKIP
         ENDWHILE
         nStartRow := Val(aData[1, 1])
         WHILE nLast>=++nCurrent
            aEval(aData, {|a| fLockRec(),;
            bvfmData->RR := Str(nStartRow+nAdder, 3),;
            bvfmData->CC := a[2],;
            dbUnlock(),;
            dbSkip()})
            nAdder += nIncrement
         ENDWHILE
         GOTO nCurRec
         vMessageOff()
         vRestore()
      ENDFUNCTION

STATIC FUNCTION AddTable()
   LOCAL cTemp
   IF !File("bvfmxsys.dbf")
      cTemp := "bvfmxsys/Name/C/30"
      fCreateDbf(cTemp)
   ENDIF
   IF !File("bvfmxfil.dbf")
      cTemp := "bvfmxfil/System/N/3//Name/C/64/Alias/C/10"
      fCreateDbf(cTemp)
   ENDIF
   IF !File("bvfmxfld.dbf")
      cTemp := "bvfmxfld/File/N/4//Name/C/10/Desc/C/30/Modifier/C/500"
      fCreateDbf(cTemp)
   ENDIF
   SELECT 0
   fShare("bvfmxsys", "xSystem")
   IF LastRec()=0
      ADDRECORD
      xSystem->Name := "@MEMORY"
      UNLOCK
   ENDIF
   SELECT 0
   fShare("bvfmxfil", "xFile")
   IF LastRec()=0
      ADDRECORD
      xFile->System := 1
      xFile->Name   := "@MEMORY"
      xFile->ALias  := "M"
      UNLOCK
   ENDIF
   IF !File("bvfmxfil.ntx")
      INDEX ON Str(Field->System, 3)+Upper(Field->Name) TO bvfmxfil
   ELSE
      SET INDEX TO bvfmxfil
   ENDIF
   SELECT 0
   fShare("bvfmxfld", "xField")
   IF !File("bvfmxfld.ntx")
      INDEX ON Str(Field->File, 4)+Upper(Field->Name) TO bvfmxfld
   ELSE
      SET INDEX TO bvfmxfld
   ENDIF
   SET KEY K_F5 TO TableNew
   SELECT bvfmData
   SET ORDER TO 0
   GO BOTTOM
   @ MaxRow(), 0 SAY "<F5> New Field"
   fBrowse()
   SET KEY K_F5 TO
   SET ORDER TO 1
   CLOSE xField
   CLOSE xFile
   CLOSE xSystem
   SELECT bvfm
ENDFUNCTION

STATIC FUNCTION TableNew()
   LOCAL nSystem, nFile, nExpression, nOption
   IF !Empty(bvfmData->Expression)
      Alert("Expression must be empty")
      RETURN NIL
   ENDIF
   nSystem := vPopWhen("Choose System", "xSystem", , "RecNo()",;
         "Name", , , .y.)
   IF nSystem=0
      RETURN NIL
   ENDIF
   SET FILTER TO xFile->System=xSystem->(RecNo()) ALIAS xFile
   GO TOP ALIAS xFile
   IF xFile->(EOF())
      nOption := Alert("There are no files associated with "+;
            Trim(xSystem->Name), {"New File", "Abort"})
      IF nOption!=1
         RETURN NIL
      ENDIF
      NewFile(nSystem)
      nFile := 1
      SET FILTER TO xField->File=1 ALIAS xField
   ELSE
      nFile := vPopWhen("Choose File", "xFile", , "RecNo()", "Alias", , , .y.)
      SET FILTER TO xField->File=xFile->(RecNo()) ALIAS xField
      GO TOP ALIAS xField
      IF xField->(EOF())
         NewField()
      ENDIF
      nExpression := vPopWhen("Choose Expression", "xField", , "RecNo()",;
            "Desc", , , .y.)
      LOCK ALIAS bvfmData
      bvfmData->Form_No := bvfm->Form_No
      bvfmData->Expression := xField->(Trim(iif(Empty(Modifier),;
            Name, Modifier)))
      bvfmData->Desc := xField->Desc
      UNLOCK ALIAS bvfmData
   ENDIF
ENDFUNCTION

STATIC FUNCTION NewFile(nSystem)
   LOCAL aRC, GetList := {}
   ADDRECORD ALIAS xFile
   xFile->System := nSystem
   vSave(2, 60)
   aRC := vWindow(2, 60, , "File To Add")
   @ aRC[1],  aRC[2] SAY "Name ....." GET xFile->Name PICTURE "@!"
   @ Row()+1, aRC[2] SAY "Alias ...." GET xFile->Alias;
         WHEN {|| xFile->Alias := xFile->Name, .y.}
   READ
   vRestore()
   UNLOCK ALIAS xFile
   NewField()
ENDFUNCTION

STATIC FUNCTION NewField()
   LOCAL aRC, GetList := {}, nOption, cImportFrom := Space(64), aStructure
   nOption := Alert("No Fields are defined for "+Trim(xFile->Alias),;
         {"Define", "Import", "Abort"})
   IF nOption=0 .or. nOption=3
      RETURN NIL
   ENDIF
   IF nOption=1
      ADDRECORD ALIAS xField
      xField->File := xFile->(RecNo())
      vSave(3, 60)
      aRC := vWindow(3, 60, .y., "Field Information")
      @ aRC[1],  aRC[2] SAY "Field Name ......" GET xField->Name
      @ Row()+1, aRC[2] SAY "Description ....." GET xField->Desc;
            WHEN {|| xField->Desc := xField->Name, .y.}
      @ Row()+1, aRC[2] SAY "Modifier ........" GET xField->Modifier;
            PICTURE "@S45"
      READ
      vRestore()
   ELSE
      vSave(1, 78)
      aRC := vWindow(1, 78)
      cImportFrom := xFile->Name+cImportFrom
      @ aRC[1],  aRC[2] SAY "Import From File Name ..." GET cImportFrom;
            PICTURE "@S50"
      READ
      vRestore()
      IF !File(cImportFrom := fExtNew(Trim(cImportFrom), "dbf"))
         Alert("File Does Not Exist")
         RETURN NIL
      ENDIF
      vMessageOn("Importing Fields...")
      SELECT 0
      fShare(Trim(cImportFrom), "Import")
      aStructure := a1From2(dbStruct(), 1)
      xField->(aEval(aStructure, {|cFieldName| fAddRecord(),;
            xField->File := xFile->(RecNo()),;
            xField->Name := xField->Desc := cFieldName,;
            xField->Modifier := Trim(xFile->(Alias))+"->"+cFieldName,;
            dbUnlock()}))
      vMessageOff()
   ENDIF
ENDFUNCTION

/*
 1.02 03/23/93 Corrected <space>// to //, made prompts for preliminary data correct
 1.02 04/07/93 Made row/col 100 characters for long expressions
*/
