/*
 * File......: CHDIR.C
 * Author....: Dave Pearson
 * BBS.......: The Dark Knight Returns
 * Net/Node..: 050/069
 * User Name.: Dave Pearson
 * Date......: $Date$
 * Revision..: $Revision$
 * Log file..: $Logfile$
 *
 * This is an original work by Dave Pearson and is placed in the public
 * domain.
 *
 * Modification history:
 * ---------------------
 *
 * $Log$
 *
 */

// NOTE: This code has been written for and compiled with Borland C++
//       Version 3.1
//

#include <extend.h>
#include "internal.h"

/*  $DOC$
 *  $FUNCNAME$
 *      GT_CHDIR()
 *  $CATEGORY$
 *      Disk Drive
 *  $ONELINER$
 *      Change the current directory.
 *  $SYNTAX$
 *      GT_ChDir(<cDir>,[@<nError>]) --> lChanged
 *  $ARGUMENTS$
 *      <cDir> is the path of the directory.
 *
 *      <nError> is an optional parameter that must be passed by reference.
 *      If the directory change fails the DOS error code will be placed in
 *      this variable.
 *  $RETURNS$
 *      If the change was made, GT_ChDir() returns true (.T.), if not it
 *      returns false (.F.).
 *  $DESCRIPTION$
 *      GT_ChDir() can be used to change the current directory.
 *  $EXAMPLES$
 *      // Change directory.
 *
 *      nError := 0
 *      if !GT_ChDir("Knight",@nError)
 *         ? "Error =",nError
 *      endif
 *  $SEEALSO$
 *      GT_MKDIR() GT_RMDIR()
 *  $END$
 */

CLIPPER GT_ChDir()
{
        _GT_Internal_Directory(0x3B);
}
