//
// CONV2GW.CH (Convert to Ghostware Lib 2.0)
//
// Header file for calling GhostWare Library version 1.0 functions
// with version 2.0
// If you used version 1.0 functions, just include this file in your
// programs. The preprocessor translates the 'old' function call to
// the 'new' equivalent.
// If you use the header file GHOST.LIB then this header file can be
// called from that file too. (the include statement is already in
// GHOST.CH)
//

// You can use this statement when compiling with Clipper 5.2
// #STDOUT Using CONV2GW.CH  - version 2.3 by GhostWare (c) 1991-1994

//
//  Conversion functions
//
#xTranslate AddMonth2Date ([<parms,...>]) => GWAddM2Date(<parms>)
#xTranslate AddYear2Date  ([<parms,...>]) => GWAddY2Date(<parms>)
#xTranslate AJoin         ([<parms,...>]) => GWAJoin(<parms>)
#xTranslate Array2String  ([<parms,...>]) => GWArray2String(<parms>)
#xTranslate Date2Week     ([<parms,...>]) => GWDate2Week(<parms>)
#xTranslate ExpandString  ([<parms,...>]) => GWExpandString(<parms>)
#xTranslate NLBedrag      ([<parms,...>]) => GWNedAmount(<parms>)
#xTranslate NLDatum       ([<parms,...>]) => GWNedDate(<parms>)
#xTranslate NLPercentage  ([<parms,...>]) => GWNedPercent(<parms>)
#xTranslate Periode       ([<parms,...>]) => GWPeriod(<parms>)
#xTranslate String2Array  ([<parms,...>]) => GWString2Array(<parms>)
#xTranslate Week2Date     ([<parms,...>]) => GWWeek2Date(<parms>)

//
//  Database functions
//
#xTranslate AddRec        ([<parms,...>]) => GWAddRec(<parms>)
#xTranslate FileLock      ([<parms,...>]) => GWFileLock(<parms>)
#xTranslate NetUse        ([<parms,...>]) => GWNetUse(<parms>)
#xTranslate RecLock       ([<parms,...>]) => GWRecLock(<parms>)
#xTranslate TB            ([<parms,...>]) => GWBrowseDBF(<parms>)

//
//  Getlist functions
//
#xtranslate CheckBoxes    ([<parms,...>]) => GWCheckBoxes(<parms>)
#xTranslate GetNummer     ([<parms,...>]) => GWGetNumber(<parms>)
#xTranslate GetVul        ([<parms,...>]) => GWGetFill(<parms>)
#xTranslate Kalender      ([<parms,...>]) => GWCalender(<parms>)
#xTranslate Post_Pick     ([<parms,...>]) => GWPostPick(<parms>)
#xTranslate Pre_Pick      ([<parms,...>]) => GWPrePick(<parms>)
#xTranslate RadioButtons  ([<parms,...>]) => GWRadioButtons(<parms>)

//
//  Log functions
//
#xTranslate DumpErrs      ([<parms,...>]) => GWErrorLog(<parms>)
#xTranslate DumpUserlog   ([<parms,...>]) => GWUserlog(<parms>)
#xTranslate DumpUsers     ([<parms,...>]) => GWUsers(<parms>)
#xTranslate Login         ([<parms,...>]) => GWLogin(<parms>)

//
//  Menu functions
//
#xTranslate MaakMenuArray ([<parms,...>]) => GWMenuArray(<parms>)
#xTranslate PDown         ([<parms,...>]) => GWPDown(<parms>)
//#xTranslate Pulldown      ([<parms,...>]) => GWPulldown(<parms>)
#xTranslate Vraag         ([<parms,...>]) => GWAsk(<parms>)

//
//  Printer functions
//
#xTranslate Blanco        ([<parms,...>]) => GWBlank(<parms>)
#xTranslate HPCopies      ([<parms,...>]) => GWHPCopies(<parms>)
#xTranslate HPFont        ([<parms,...>]) => GWHPFont(<parms>)
#xTranslate HPLandscape   ([<parms,...>]) => GWHPLandscape(<parms>)
#xTranslate HPLeftMargin  ([<parms,...>]) => GWHPLeftMargin(<parms>)
#xTranslate HPLPI         ([<parms,...>]) => GWHPLPI(<parms>)
#xTranslate HPPitch       ([<parms,...>]) => GWHPPitch(<parms>)
#xTranslate HPPointSize   ([<parms,...>]) => GWHPPointSize(<parms>)
#xTranslate HPPortrait    ([<parms,...>]) => GWHPPortrait(<parms>)
#xTranslate HPReset       ([<parms,...>]) => GWHPReset(<parms>)
#xTranslate HPSpacing     ([<parms,...>]) => GWHPSpacing(<parms>)
#xTranslate HPStroke      ([<parms,...>]) => GWHPStroke(<parms>)
#xTranslate HPStyle       ([<parms,...>]) => GWHPStyle(<parms>)
#xTranslate HPTypeface    ([<parms,...>]) => GWHPTypeface(<parms>)
#xTranslate Kyo_Aan       ([<parms,...>]) => GWKyoOn (<parms>)
#xTranslate Kyo_Code      ([<parms,...>]) => GWKyoCode(<parms>)
#xTranslate Kyo_Uit       ([<parms,...>]) => GWKyoOff(<parms>)
#xTranslate LPT1Check     ([<parms,...>]) => GWLPT1Check(<parms>)
#xTranslate PageFull      ([<parms,...>]) => GWPageFull(<parms>)
#xTranslate Printer_Aan   ([<parms,...>]) => GWPrintOn(<parms>)
#xTranslate Printer_Uit   ([<parms,...>]) => GWPrintOff(<parms>)

//
//  Screen functions
//
#xTranslate AUB           ([<parms,...>]) => GWWatch(<parms>)
#xTranslate Explode       ([<parms,...>]) => GWExplode(<parms>)
#xTranslate Implode       ([<parms,...>]) => GWImplode(<parms>)
#xTranslate Message       ([<parms,...>]) => GWMessage(<parms>)
#xTranslate RestScherm    ([<parms,...>]) => GWRestScreen(<parms>)
#xTranslate SaveScherm    ([<parms,...>]) => GWSaveScreen(<parms>)
#xTranslate SBox          ([<parms,...>]) => GWSBox(<parms>)
#xTranslate SchoonScherm  ([<parms,...>]) => GWClearScreen(<parms>)
#xTranslate ShadowBox     ([<parms,...>]) => GWShadowBox(<parms>)
#xTranslate Spin          ([<parms,...>]) => GWSpin(<parms>)
#xTranslate StatusBalk    ([<parms,...>]) => GWStatusBar(<parms>)
#xTranslate StatusRegel   ([<parms,...>]) => GWStatusLine(<parms>)
#xTranslate ToonLogo      ([<parms,...>]) => GWShowLogo(<parms>)

//
//  Miscellaneous functions
//
#xTranslate CopyFile      ([<parms,...>]) => GWCopyFile(<parms>)
#xTranslate Delay         ([<parms,...>]) => GWDelay(<parms>)
#xTranslate FakeKey       ([<parms,...>]) => GWFakeKey(<parms>)
#xTranslate GetDir        ([<parms,...>]) => GWGetDir(<parms>)
#xTranslate GWTextBrowse  ([<parms,...>]) => GWBrowseText(<parms>)
#xTranslate Help          ([<parms,...>]) => GWHelp(<parms>)
#xTranslate IsValid       ([<parms,...>]) => GWIsValid(<parms>)
#xTranslate Muziek        ([<parms,...>]) => GWMusic(<parms>)
#xTranslate PassWord      ([<parms,...>]) => GWPassWord(<parms>)
#xTranslate Size          ([<parms,...>]) => GWSize(<parms>)
#xTranslate TBArr         ([<parms,...>]) => GWBrowseArray(<parms>)
#xTranslate WaitKey       ([<parms,...>]) => GWWaitKey(<parms>)
#xTranslate WhatIsThis    ([<parms,...>]) => GWWhatIsThis(<parms>)
