/*****************************************************************************
*  Header File : GWMENU.CH                                                   *
*                                                                            *
*       Author : R.P.J. van Geest                                            *
*    Copyright : 1993-1994 - (c) GhostWare                                   *
*                                                                            *
*  Description : Header file for the GhostWare libraries GHOST.LIB,          *
*                GHOSTHOL.LIB and GHOSTUSA.LIB                               *
*                                                                            *
* Date created : 24-03-94       updated : 24-03-94                          *
* Time created : 13:11:13       updated : 13:21:51                          *
*****************************************************************************/

// You can use this statement when compiling with Clipper 5.2
#STDOUT Using GWMENU.CH   - version 2.3 by GhostWare (c) 1991-1994

#XCOMMAND BEGIN MENU <aMenu>           ;
            =>                         ;
          _GWMakeMenu(<"aMenu">)

#XCOMMAND ENDMENU <aMenu>              ;
            =>                         ;
          <aMenu> := _GWEndMenu(<"aMenu">)

#XCOMMAND OPTION <cOption>             ;
          [<d1: DO, EXECUTE> <bDo>]    ;
          [<h1: HOTKEY> <nHotkey>]     ;
          [<m1: MESSAGE> <cMessage>]   ;
          [<w1: WHEN> <cWhen>]         ;
          [SHORTCUT <nShortCut>] ;
            =>                         ;
          _GWAddMenu({                 ;
          <cOption>,                   ;
          IIF(<.h1.>, <nHotkey>, 1),   ;
          <{bDo}>,                     ;
          IIF(<.m1.>, <cMessage>, ""), ;
          IIF(<.w1.>, <{cWhen}>, .T.)},;
          <nShortCut>)                 ;

#XCOMMAND OPTION <cOption>             ;
          [<s1: SUBMENU> <cSubmenu>]   ;
          [<h1: HOTKEY> <nHotkey>]     ;
          [<m1: MESSAGE> <cMessage>]   ;
          [<w1: WHEN> <cWhen>]         ;
            =>                         ;
          _GWAddMenu({                 ;
          <cOption>,                   ;
          IIF(<.h1.>, <nHotkey>, 1),   ;
          <cSubmenu>,                  ;
          IIF(<.m1.>, <cMessage>, ""), ;
          IIF(<.w1.>, <{cWhen}>, .T.)},;
          NIL)

#XCOMMAND SEPARATOR                    ;
            =>                         ;
          _GWAddMenu({NIL})

#XCOMMAND ACTIVATE MENU <aMenu>                  ;
	  [OPTION [COLOR] <cColOption>]          ;
	  [HOTKEY [COLOR] <cColHotkey>]          ;
	  [ACTIVEOPTION [COLOR] <cColActOption>] ;
	  [ACTIVEHOTKEY [COLOR] <cColActHotkey>] ;
	  [BORDER <cBorder>]                     ;
	  [<explode:EXPLODE>]                    ;
	  [<warning:WARNING>]                    ;
	  [BLOCK <cBlock> [AFTER <nSeconds>]]    ;
	  [TOPROW <nTop>]                        ;
	  [MESSAGEROW <nMessage>]                ;
	    =>                                   ;
          GWPDown(<aMenu>, <cColOption>,         ;
                  <cColHotkey>, <cColActOption>, ;
                  <cColActHotkey>, <cBorder>,    ;
                  <.explode.>, <.warning.>,      ;
                  <nSeconds>, <{cBlock}>,        ;
                  {<nTop>, <nMessage>})
