******************************************************************************
*     Filename : GW_DEMO.PRG                                                 *
*  Application : Ghostware Clipper 5.x libraries                             *
*                                                                            *
*       Author : R.P.J. van Geest                                            *
*   RMake File : GHOST.RMK                                                   *
*    .LIB File : GHOST.LIB, MGHOST.LIB                                       *
* Compile with : CLIPPER GW_DEMO /A /Q /P /W                                 *
*                                                                            *
*    Copyright : 1993 - (c) GhostWare                                        *
******************************************************************************
#INCLUDE "INKEY.CH"
#INCLUDE "BOX.CH"
#INCLUDE "GHOST.CH"
#INCLUDE "MOUSE.CH"
#INCLUDE "EVENTS.CH"
#INCLUDE "QUERY.CH"
#INCLUDE "GW_DEMO.CH"

STATIC scBackGround                    // Background character(s) var.
STATIC saHotSpot                       // Array for defined hotspots

PROCEDURE GW_DEMO

LOCAL aMenu, aPd1, aPd1a, aPd1b, aPd1c, aPd1d, aPd1e, aPd1i, aPd1k, ;
	aPd1l, aPd2, aPd3
LOCAL lMouse, lModColor
GWSaveEnv()                            // Save the (DOS) environment

SET MOUSE ON                           // Activate mouse support
lMouse:=GWmPresent()                   // Check mouse availability

SET GRAPH ON                           // Use the GhostWare special char.set

SET EXPLOSION OFF                      // Display boxes exploding

// Screensaver after 30 seconds
SET SCREENSAVER TO GWShuffle({|| GWAsk("This box is shown every 30 seconds!") }, 30) AFTER 30

SET SHADOWHEIGHT TO 1                  // Set default shadow height to 1

uInitialize()                          // Initialize some things

lModColor := GWEnableColor()           // Enable the redefinition of VGA colors

SETCURSOR(0)
SET DATE DUTCH                         // Defined in GHOST.CH
SET CENTURY ON
SET CONFIRM ON
SET SCOREBOARD OFF
SETBLINK(.F.)

GWClearScreen("W+/G", scBackGround)

//
// Create the pulldown menu arrays
//
BEGIN MENU aPd1a
	OPTION "GWAsk() window color"                      DO GWcChange("GWASK1")
	OPTION "GWAsk() selection bar color"               DO GWcChange("GWASK2")
	OPTION "gEt window standard color"        HOTKEY 2 DO GWcChange("GETSTANDARD")
	OPTION "geT window enhanced color"        HOTKEY 3 DO GWcChange("GETENHANCED")
	OPTION "get Window unselected color"      HOTKEY 5 DO GWcChange("GETUNSELECTED")
	SEPARATOR
	OPTION "gHostware color system functions" HOTKEY 2 DO uPd1a1()
	OPTION "Other color functions"                     DO uPd1a2()
ENDMENU aPd1a

BEGIN MENU aPd1b
	OPTION "functions for Arrays"   HOTKEY 15 DO uPd1b1()
	OPTION "functions for Dates"    HOTKEY 15 DO uPd1b2()
	OPTION "functions for Numerics" HOTKEY 15 DO uPd1b3()
	OPTION "functions for Strings"  HOTKEY 15 DO uPd1b4()
ENDMENU aPd1b

BEGIN MENU aPd1c
	OPTION "Network functions" DO uPd1c1()
	OPTION "Browse a DBF"      DO uPd1c2()
	OPTION "Simple reporting"  DO uPd1c3()
	OPTION "sTatistics"        DO uPd1c4() HOTKEY 2
ENDMENU aPd1c

BEGIN MENU aPd1d
	OPTION "Check existence of drive"           DO uPd1d1()
	OPTION "Display memory status"              DO GWMemory()
	OPTION "computer Speed"           HOTKEY 10 DO GWAsk("According to the GhostWare function GWSpeed(), the relative processor speed of your PC compared with an IBM model 30 is :"+STR(GWSpeed(),4,1))
	OPTION "display Tree information" HOTKEY 9  DO uPd1d4()
	OPTION "Other DOS functions"                DO uPd1d5()
ENDMENU aPd1d

BEGIN MENU aPd1e
	OPTION "Functions demo" DO uPd1e1(lMouse)
	OPTION "Getsys changes" DO uPd1e2()
ENDMENU aPd1e

BEGIN MENU aPd1i
	OPTION "Browse an array"                DO uPd1i1()
	OPTION "bRowse a textfile"     HOTKEY 2 DO uPd1i2()
	OPTION "Other misc. functions"          DO uPd1i4()
ENDMENU aPd1i

BEGIN MENU aPd1k
	OPTION "Clear the screen"                DO uPd1k1()
	OPTION "Display a message"               DO uPd1k2()
	OPTION "Screensavers"                    DO uPd1k3()
	OPTION "sPinning the screen"    HOTKEY 2 DO uPd1k4()
	OPTION "Other screen functions"          DO uPd1k5()
ENDMENU aPd1k

BEGIN MENU aPd1l
	OPTION "Character redefinition and so on" DO uPd1l1()
	OPTION "RGB color redefinition"           DO uPd1l2()
	OPTION "Modify the RGB definition"        DO GWModColor() WHEN lModColor
ENDMENU aPd1l

BEGIN MENU aPd1
	OPTION "Color functions  "                  SUBMENU aPd1a
	OPTION "cOnversion functions  "    HOTKEY 2 SUBMENU aPd1b
	OPTION "Database functions  "               SUBMENU aPd1c
	OPTION "dos Functions  "           HOTKEY 5 SUBMENU aPd1d
	OPTION "Getlist functions  "                SUBMENU aPd1e
	OPTION "Log functions"                       DO uPd1f1()
	OPTION "Menu functions"                      DO uPd1g1()
	OPTION "moUse functions"            HOTKEY 3 DO uPd1h1()   WHEN lMouse
	OPTION "mIscellaneous functions  " HOTKEY 2 SUBMENU aPd1i
	OPTION "Printer functions"                   DO uPd1j1()
	OPTION "Screen functions  "                 SUBMENU aPd1k
	OPTION "Video functions  "                  SUBMENU aPd1l
ENDMENU aPd1

BEGIN MENU aPd2
	OPTION "GhostWare Library       (CTRL-F10)" DO uPd2a1() SHORTCUT K_CTRL_F10
	OPTION "Benefits of registering" DO uPd2a2()
	OPTION "Read the READ.ME file"   DO uPd2a3()
ENDMENU aPd2

BEGIN MENU aPd3
	OPTION "Change menu option color"                        DO GWcChange("PDOPTION")
	OPTION "cHange menu option hotkey"              HOTKEY 2 DO GWcChange("PDHOTKEY")
	OPTION "chAnge menu active option color"        HOTKEY 3 DO GWcChange("PDACTIVEOPTION")
	OPTION "chaNge menu active option hotkey color" HOTKEY 4 DO GWcChange("PDACTIVEHOTKEY")
ENDMENU aPd3

BEGIN MENU aMenu
	OPTION "Function demo" SUBMENU aPd1 MESSAGE "Demo GhostWare functions"
	OPTION "About"         SUBMENU aPd2 MESSAGE "About GhostLib"
	OPTION "Menu colors"   SUBMENU aPd3 MESSAGE "Change this pulldown menu colors"
ENDMENU aMenu
//
// End of creating the pulldown menu arrays
//

//
// Draw and define some hotspots
//
GWBOX AT  2, 55, 20,76 BORDER SPACE(9) COLOR "W+/B"
@3,58 SAY "Click on one of" COLOR "W+/B"
@4,58 SAY "these hotspots" COLOR "W+/B"
GWBOX AT  6, 58,  9,73 BORDER B_THICK+" " LEVEL 0
@7,60 SAY " [CTRL-F1]"
@8,60 SAY "About GWLib"
GWBOX AT 11, 58, 14,73 BORDER B_THICK+" " LEVEL 0
@12,60 SAY " [CTRL-F2]"
@13,60 SAY "Registering"
GWBOX AT 16, 58, 19,73 BORDER B_THICK+" " LEVEL 0
@17,60 SAY " [CTRL-F3]"
@18,60 SAY "READ.ME file"

saHotSpot:=ARRAY(3)
DEFINE HOTSPOT saHotSpot[1] AT  6,58, 9,73 KEY K_CTRL_F1 DO uPd2a1() WARM "W+/R" COLD "N/R"
DEFINE HOTSPOT saHotSpot[2] AT 11,58,14,73 KEY K_CTRL_F2 DO uPd2a2() WARM "W+/R" COLD "N/R"
DEFINE HOTSPOT saHotSpot[3] AT 16,58,19,73 KEY K_CTRL_F3 DO uPd2a3() WARM "W+/R" COLD "N/R"
//
// End of drawing and defining hotspots
//

ACTIVATE MENU aMenu                    // Activate the menu system

SET MOUSE OFF                          // De-activate mouse support

// Delete the demo files
KillFiles("CD.*")                      // Defined in GHOST.CH
KillFiles("GENRE.*")

GWRestEnv()                            // Restore the DOS environment

GWDisableColor()                       // Disable color redefinition

RETURN

******************************************************************************
*    Function : uInitialize()                                                *
* Description : Initialize static color array, and redefinition of a few     *
*               characters                                                   *
*                                                                            *
* Date / time : 07-10-93 20:49                                               *
******************************************************************************
FUNCTION uInitialize()
LOCAL nScanLines := GWScanLines()      // Number of scanlines per character
LOCAL cFont, a214:=ARRAY(nScanLines), a215:=ARRAY(nScanLines), ;
	a216:=ARRAY(nScanLines)

GWcInit()
GWcDefine("GWASK1",        "W+/R", "GWAsk() window color")
GWcDefine("GWASK2",        "N/W",  "GWAsk() selection bar color")
GWcDefine("GETSTANDARD",   "W+/B", "Getlist standard color")
GWcDefine("GETENHANCED",   "W+/R", "Getlist enhanced color")
GWcDefine("GETUNSELECTED", "W+/G", "Getlist unselected color")

// If EGA or VGA is available the redefine a few characters
IF GWIsEGA() .OR. GWIsVGA()
	// Redefinitions of 3 characters for the background
	a214[1]  := "        " ; a215[1]  := "        " ;a216[1]  := "        "
	a214[2]  := "        " ; a215[2]  := "        " ;a216[2]  := "        "
	a214[3]  := "   11111" ; a215[3]  := "  11    " ;a216[3]  := "   11   "
	a214[4]  := "  111111" ; a215[4]  := "  11    " ;a216[4]  := "   11   "
	a214[5]  := "  11    " ; a215[5]  := "  11   1" ;a216[5]  := "   11   "
	a214[6]  := "  11    " ; a215[6]  := "  11   1" ;a216[6]  := "   11   "
	a214[7]  := "  11    " ; a215[7]  := "   11  1" ;a216[7]  := "  11    "
	a214[8]  := "  11    " ; a215[8]  := "   11 11" ;a216[8]  := "1 11    "
	a214[9]  := "  11  11" ; a215[9]  := "   11111" ;a216[9]  := "1111    "
	a214[10] := "  11  11" ; a215[10] := "   1111 " ;a216[10] := "1111    "
	a214[11] := "  11   1" ; a215[11] := "    111 " ;a216[11] := "111     "
	a214[12] := "  11   1" ; a215[12] := "    111 " ;a216[12] := "111     "
	a214[13] := "  111111" ; a215[13] := "    11  " ;a216[13] := " 11     "
	a214[14] := "   11111" ; a215[14] := "    11  " ;a216[14] := " 11     "
	IF nScanLines>14               // In case of VGA adapter
		a214[15] := "        " ; a215[15] := "        " ;a216[15] := "        "
		a214[16] := "        " ; a215[16] := "        " ;a216[16] := "        "
	ENDIF

// Another example of redefined characters :
// 	a214[1]  := "        " ; a215[1]  := "        " ;a216[1]  := "        "
// 	a214[2]  := "11      " ; a215[2]  := "        " ;a216[2]  := "      11"
// 	a214[3]  := "1111    " ; a215[3]  := "        " ;a216[3]  := "    11  "
// 	a214[4]  := "111111  " ; a215[4]  := "        " ;a216[4]  := "  11  11"
// 	a214[5]  := "11111111" ; a215[5]  := "        " ;a216[5]  := "11  11  "
// 	a214[6]  := "11111111" ; a215[6]  := "11    11" ;a216[6]  := "  11  11"
// 	a214[7]  := "11111111" ; a215[7]  := "1111111 " ;a216[7]  := "11  11  "
// 	a214[8]  := "11111111" ; a215[8]  := "11111  1" ;a216[8]  := "  11  11"
// 	a214[9]  := "11111111" ; a215[9]  := "1111 11 " ;a216[9]  := "11  11  "
// 	a214[10] := "11111111" ; a215[10] := "11111  1" ;a216[10] := "  11  11"
// 	a214[11] := "11111111" ; a215[11] := "1111 11 " ;a216[11] := "11  11  "
// 	a214[12] := "  111111" ; a215[12] := "11111  1" ;a216[12] := "  11    "
// 	a214[13] := "    1111" ; a215[13] := "1111 11 " ;a216[13] := "11      "
// 	a214[14] := "      11" ; a215[14] := "11111  1" ;a216[14] := "        "
// 	IF nScanLines>14               // In case of VGA adapter
// 	a214[15] := "        " ; a215[15] := "1111 11 " ;a216[15] := "        "
// 	a214[16] := "        " ; a215[16] := "  111   " ;a216[16] := "        "
// 	ENDIF

	cFont := GWMakeChar(a214)
	cFont += GWMakeChar(a215)
	cFont += GWMakeChar(a216)

	GWLoadFont(cFont, 214, 0)      // Characters 200, 201 and 202 are redefined
	scBackGround := "    "      // Redefined chars for background use
ELSE
	scBackGround := ""            // Simple background char for Mono/CGA
ENDIF

uMakeDBFs()                      // Create some files for this demo

RETURN NIL

******************************************************************************
*    Function : uMakeDBFs()                                                  *
* Description : Create some DBFs for this demo program                       *
*                                                                            *
* Date / time : 03-06-94 20:13                                               *
******************************************************************************
STATIC FUNCTION uMakeDBFs()
LOCAL aStruct := {}, i:=1
LOCAL aGenre := { ;
	{1,"Pop"},;
	{2,"Rock"},;
	{3,"Symphonic Rock"},;
	{4,"Hard Rock"} }
LOCAL aData := { ;
	{"ABBA","Arrival",1976,1,12},;
	{"Adams, Brian","ReckLess",1984,2,13},;
	{"Asia","Astra",1985,2,9},;
	{"Bush, Kate","The kick inside",1978,1,10},;
	{"Clapton, Eric","Unplugged",1992,2,13}, ;
	{"Dire Straits","Love over gold",1982,2,7}, ;
	{"Genesis","The lamb lies down on Broadway",1974,3,5}, ;
	{"Houston, Whitney","I'm your baby tonight",1990,1,11}, ;
	{"Moore, Gary","Still got the blues",1990,4,12}, ;
	{"Pink Floyd","Delicate sound of thunder",1988,3,11}, ;
	{"Plant, Robert","Manic Nirvana",1993,4,11}, ;
	{"Queen","Innuendo",1991,2,10}, ;
	{"Roxy Music","Avalon",1982,2,13}, ;
	{"Sting","The soul cages",1991,2,10}, ;
	{"U2","Rattle and hum",1988,4,14}, ;
	{"Yes","90125",1983,3,10}, ;
	{"ZZTop","Eliminator",1983,4,11} }

// Create GENRE.DBF
AADD(aStruct, {"Code", 	"N", 2, 0})
AADD(aStruct, {"Text",	"C", 14, 0})
DBCREATE("GENRE", aStruct)
GWNetUse("GENRE", , "S", "N", 5)
// Fill GENRE.DBF
FOR i := 1 TO LEN(aGenre)
	GWAddRec(5)
	GENRE->CODE := aGenre[i,1]
	GENRE->TEXT := aGenre[i,2]
NEXT
DBCOMMIT()
DBUNLOCK()
DBGOTOP()
INDEX ON GENRE->CODE TO GENRE
DBCLOSEAREA()

// Create CD.DBF
aStruct := {}
AADD(aStruct, {"Group", 		"C", 16, 0})
AADD(aStruct, {"Title", 		"C", 25, 0})
AADD(aStruct, {"Year",    	"N",  4, 0})
AADD(aStruct, {"Genre", 		"N",  2, 0})
AADD(aStruct, {"Songs", 		"N",  2, 0})
DBCREATE("CD", aStruct)
GWNetUse("CD", , "S", "N", 5)
// Fill CD.DBF
FOR i := 1 TO LEN(aData)
	GWAddRec(5)
	CD->GROUP := aData[i,1]
	CD->TITLE := aData[i,2]
	CD->YEAR  := aData[i,3]
	CD->GENRE := aData[i,4]
	CD->SONGS := aData[i,5]
NEXT
DBCOMMIT()
DBUNLOCK()
DBGOTOP()
INDEX ON CD->GENRE TO CD
DBCLOSEAREA()

RETURN NIL

******************************************************************************
*    Function : uPd1a1()                                                     *
* Description : Demo Color functions, gHostware color system functions       *
*                                                                            *
*   Functions : GWAJoin(), GWArray2String(), GWString2Array()                *
*                                                                            *
* Date / time : 15-06-93 20:52                                               *
******************************************************************************
STATIC FUNCTION uPd1a1()

LOCAL cText

GWStatusLine("Demo GhostWare GhostWare color system functions",0)

cText := "GhostWare color system functions :"+GWCRLF()+GWCRLF()
cText += "GWcActive()   - Check if GhostWare color system is activated"+GWCRLF()
cText += "GWcArray()    - Save and restore the GhostWare color array"+GWCRLF()
cText += "GWcChange()   - Change a color interactively"+GWCRLF()
cText += "GWcDefine()   - Define a color in the GhostWare color array"+GWCRLF()
cText += "GWcDelete()   - Delete a color from the GhostWare color array"+GWCRLF()
cText += "GWcExist()    - Check if a color exists in the GhostWare color array"+GWCRLF()
cText += "GWcInit()     - Initialize the GhostWare color system"+GWCRLF()
cText += "GWcKill()     - Kill the GhostWare color array"+GWCRLF()
cText += "GWcSetColor() - GhostWare color system equivalent for SETCOLOR()"+GWCRLF()
cText += "GWcString()   - Compose a color string to be used in function calls"

GWAsk(cText,,,GWASKCOLOR,,2)

RETURN(NIL)

******************************************************************************
*    Function : uPd1a2()                                                     *
* Description : Demo Color functions, Other color functions                  *
*                                                                            *
*   Functions : GWAJoin(), GWArray2String(), GWString2Array()                *
*                                                                            *
* Date / time : 15-06-93 20:53                                               *
******************************************************************************
STATIC FUNCTION uPd1a2()

LOCAL cText

GWStatusLine("Demo GhostWare Other color functions",0)

cText := "GhostWare Other color functions :"+GWCRLF()+GWCRLF()
cText += "GWBorder()      - Get/set the border color"+GWCRLF()
cText += "GWChangeColor() - Choose a color with the cursor keys or a mouse"+GWCRLF()
cText += "GWColor2Num()   - Convert a color string into a numeric value"+GWCRLF()
cText += "GWEnhanced()    - Get/set the enhanced color"+GWCRLF()
cText += "GWNum2Color()   - Convert a numeric value into a color string"+GWCRLF()
cText += "GWSplitColor()  - Split a color string into 5 colors"+GWCRLF()
cText += "GWStandard()    - Get/set the standard color"+GWCRLF()
cText += "GWUnselected()  - Get/set the unselected color"

GWAsk(cText,,,GWASKCOLOR,,5)

RETURN(NIL)

******************************************************************************
*    Function : uPd1b1()                                                     *
* Description : Demo Conversion functions, functions for Arrays              *
*                                                                            *
*   Functions : GWAJoin(), GWArray2String(), GWString2Array()                *
*                                                                            *
* Date / time : 26-01-93 20:21                                               *
******************************************************************************
STATIC FUNCTION uPd1b1()

LOCAL cText

GWStatusLine("Demo GhostWare Library functions for ARRAYS",0)
cText := "GhostWare Library functions for ARRAYS :"+GWCRLF()+GWCRLF()
cText += "GWJoin() - Joins 2 arrays of the same dimension"+GWCRLF()+GWCRLF()
cText += "GWArray2String() - Convert an array to a delimited string"+GWCRLF()
cText += 'e.g. GWArray2String({"A","B","C"}, ";") -> "A;B;C"'+GWCRLF()+GWCRLF()
cText += "GWString2Array() - Convert a delimited string to an array"+GWCRLF()
cText += 'e.g. GWString2Array("A;B;C", ";") -> {"A","B","C"}'+GWCRLF()+GWCRLF()

GWAsk(cText,,,GWASKCOLOR)

RETURN(NIL)

******************************************************************************
*    Function : uPd1b2()                                                     *
* Description : Demo Conversion functions, functions for Dates               *
*                                                                            *
*   Functions : GWAddM2Date(), GWAddY2Date(), GWBom(), GWDate2Week()         *
*               GWIsLeapYear(), GWNedDate(), GWPeriod(), GWWorkDays()        *
*                                                                            *
* Date / time : 26-01-93 20:21                                               *
******************************************************************************
STATIC FUNCTION uPd1b2()

LOCAL aScreen, cOldColor := SETCOLOR(GETCOLOR)
LOCAL nT:=4, nL:=5, nB:=22, nR:=73, GETLIST:={}
LOCAL dStart:=DATE(), dEnd:=DATE()+14, nMonth:=0, nYear:=0

GWStatusLine("Demo GhostWare Library functions for DATES",0)

DO WHILE .T.
	IF aScreen != NIL
		GWRestScreen(aScreen)
	ENDIF

	aScreen := GWShadowBox(nT, nL, nB, nR, SETCOLOR(), 1)
	@nT+1,nL+3 SAY "Starting date :" GET dStart
	@nT+2,nL+3 SAY "Ending date   :" GET dEnd
	@nT+3,nL+3 SAY "Months to add :" GET nMonth
	@nT+4,nL+3 SAY "Years to add  :" GET nYear
	READ

	IF LASTKEY()==K_ESC
		EXIT
	ENDIF

	@nT+6, nL+3 SAY 'GWAddM2Date( CTOD("'+ DTOC(dStart) +'"), '+ ALLTRIM(STR(nMonth)) +' ) -> '+DTOC(GWAddM2Date(dStart, nMonth))
	@nT+7, nL+3 SAY 'GWAddY2Date( CTOD("'+ DTOC(dStart) +'"), '+ ALLTRIM(STR(nYear)) +' ) -> '+DTOC(GWAddY2Date(dStart, nYear))
	@nT+9, nL+3 SAY 'GWBoM( CTOD("'+ DTOC(dStart) +'" ) -> '+DTOC(GWBoM(dStart))
	@nT+10, nL+3 SAY 'GWDate2Week( CTOD("'+ DTOC(dStart) +'" ) -> '+ALLTRIM(STR(GWDate2Week(dStart)))
	@nT+12, nL+3 SAY 'GWIsLeapYear( CTOD("'+ DTOC(dStart) +'" ) -> '+IIF(GWIsLeapYear(dStart),'.T.','.F.')
	@nT+14, nL+3 SAY 'GWNedDate( CTOD("'+ DTOC(dStart) +'", 3 ) -> '+GWNedDate(dStart, 3)
	@nT+16, nL+3 SAY 'GWPeriod( CTOD("'+ DTOC(dStart) +'"), CTOD("'+ DTOC(dEnd) +'") )[6] -> '+ALLTRIM(STR(GWPeriod(dStart, dEnd)[6]))
	@nT+17, nL+3 SAY 'GWWorkDays( CTOD("'+ DTOC(dStart) +'"), CTOD("'+ DTOC(dEnd) +'") ) -> '+ALLTRIM(STR(GWWorkDays(dStart, dEnd)))

	IF GWAsk("Again?", {"Yes","No"},, GWASKCOLOR,, 2, 49)==2
		EXIT
	ENDIF

ENDDO

GWRestScreen(aScreen)

SETCOLOR(cOldColor)

RETURN(NIL)

******************************************************************************
*    Function : uPd1b3()                                                     *
* Description : Demo Conversion functions, functions for Numerics            *
*                                                                            *
*   Functions : GWIsNumeric(), GWNedAmount(), GWNedPercent()                 *
*                                                                            *
* Date / time : 26-01-93 20:21                                               *
******************************************************************************
STATIC FUNCTION uPd1b3()

LOCAL aScreen, cOldColor := SETCOLOR(GETCOLOR)
LOCAL nT:=4, nL:=6, nB:=14, nR:=63, GETLIST:={}
LOCAL cValue:="        ", nAmount:=0, nPerc:=0

GWStatusLine("Demo GhostWare Library functions for NUMERICS",0)

DO WHILE .T.
	IF aScreen != NIL
		GWRestScreen(aScreen)
	ENDIF

	aScreen := GWShadowBox(nT, nL, nB, nR, SETCOLOR(), 1)
	@nT+1,nL+3 SAY "Value to check for only numerics :" GET cValue
	@nT+2,nL+3 SAY "Amount to print                  :" GET nAmount PICTURE '#######.##'
	@nT+3,nL+3 SAY "Percentage to print              :" GET nPerc PICTURE '#######.##'
	READ

	IF LASTKEY()==K_ESC
		EXIT
	ENDIF

	@nT+5, nL+3 SAY 'GWIsNumeric( '+ ALLTRIM(cValue) +' ) -> '+IIF(GWIsNumeric(cValue),'.T.','.F.')
	@nT+7, nL+3 SAY 'GWNedAmount( '+ ALLTRIM(STR(nAmount)) +', 12, 2 ) -> '+GWNedAmount(nAmount,12,2)
	@nT+9, nL+3 SAY 'GWNedPercent( '+ ALLTRIM(STR(nPerc)) +', 12, 2 ) -> '+GWNedPercent(nPerc,12,2)

	IF GWAsk("Again?",{"Yes","No"},,GWASKCOLOR,,2,55)==2
		EXIT
	ENDIF

ENDDO

GWRestScreen(aScreen)

SETCOLOR(cOldColor)

RETURN(NIL)

******************************************************************************
*    Function : uPd1b4()                                                     *
* Description : Demo Conversion functions, functions for Strings             *
*                                                                            *
*   Functions : GWExpandString(), GWStrTran()                                *
*                                                                            *
* Date / time : 26-01-93 20:21                                               *
******************************************************************************
STATIC FUNCTION uPd1b4()

LOCAL aScreen, aScreen2, cOldColor := SETCOLOR(GETCOLOR)
LOCAL nT:=4, nL:=6, nB:=10, nR:=58, GETLIST:={}
LOCAL cValue:="GhostWare", cExpand:="  "

GWStatusLine("Demo GhostWare Library functions for STRINGS",0)

DO WHILE .T.
	IF aScreen != NIL
		GWRestScreen(aScreen)
		GWRestScreen(aScreen2)
	ENDIF

	aScreen := GWShadowBox(nT, nL, nB, nR, SETCOLOR(), 1)
	@nT+1,nL+3 SAY "String to expand  :" GET cValue
	@nT+2,nL+3 SAY "Expand characters :" GET cExpand
	READ

	IF LASTKEY()==K_ESC
		EXIT
	ENDIF

	@nT+4, nL+3 SAY 'GWExpandString( "'+ cValue +'", "'+ cExpand +'" )'
	@nT+5, nL+3 SAY ' -> '+GWExpandString(ALLTRIM(cValue),cExpand)
	aScreen2 := GWMessage('Other string functions : GWArray2String(), GWStrTran(), GWDecrypt(), GWEncrypt()', GWASKCOLOR, 13)

	IF GWAsk("Again?",{"Yes","No"},,GWASKCOLOR,,2,50)==2
		EXIT
	ENDIF

ENDDO

GWRestScreen(aScreen)
GWRestScreen(aScreen2)

SETCOLOR(cOldColor)

RETURN(NIL)

******************************************************************************
*    Function : uPd1c1()                                                     *
* Description : Demo Database functions, Network functions                   *
*                                                                            *
*   Functions : GWAddRec(), GWFileLock(), GWNetUse(), GWRecLock()            *
*                                                                            *
* Date / time : 26-01-93 22:29                                               *
******************************************************************************
STATIC FUNCTION uPd1c1()

LOCAL cText

GWStatusLine("Demo GhostWare Library Network functions",0)

cText := "GhostWare Library Network functions :"+GWCRLF()+GWCRLF()
cText += "GWAddRec()   - network version for DBAPPEND()"+GWCRLF()
cText += "GWFileLock() - locking a file on a network"+GWCRLF()
cText += "GWNetUse()   - use a file, shared or exclusive on a network"+GWCRLF()
cText += "GWRecLock()  - locking a record on a network"+GWCRLF()+GWCRLF()
cText += "GWOpenDBF()  - show a window with all the open databases"

GWAsk(cText,,,GWASKCOLOR,,5)

RETURN(NIL)

******************************************************************************
*    Function : uPd1c2()                                                     *
* Description : Demo Database functions, Browse a DBF                        *
*                                                                            *
*   Functions : GWBrowseDBF()                                                *
*                                                                            *
* Date / time : 26-01-93 22:32                                               *
******************************************************************************
STATIC FUNCTION uPd1c2()
LOCAL aFields, aScreen

GWStatusLine("Demo GhostWare Library Browse a DBF",0)

// Open the files and set a relation
//
// Database File: GENRE.DBF
//
// Field  FieldName  Type  Width  Decimals
//        
//   1    CODE        N      2       0
//   2    TEXT        C     14       0
//
GWNetUse("GENRE", "GENRE", "S", "N", 5)

//
// Database File: CD.DBF
//
// Field  FieldName  Type  Width  Decimals
//        
//   1    GROUP       C     16       0
//   2    TITLE       C     25       0
//   3    YEAR        N      4       0
//   4    GENRE       N      4       0
//   5    SONGS       N      2       0
//
GWNetUse("CD", , "S", "N", 5)
DBSETRELATION("GENRE", {|| CD->GENRE })

// These statements can be used only with Clipper 5.2
SETKEY(K_ALT_O, {|| GWOpenDBF(.T.) })
GWStatusLine("Press Alt-O to let GWOpenDBF() show what files are open")

aFields :={"Group","Title","Year","GENRE->TEXT"}

aScreen := GWMessage("Data is browsed directly from the database files with the GWDBFBROWSE command. Press ESCape to continue.", GWASKCOLOR, 15)
GWDBFBROWSE AT 3,5,11,72 FIELDS aFields EDIT DEL ADD SPACEEDIT COUNTER ;
	HORIZONTAL VERTICAL FREEZE 1 RESTORE HELPLINE
GWRestScreen(aScreen)

aScreen := GWMessage("The same data is now browsed from an array with the GWARRBROWSE command. The array is created with GWDBF2Array(). Press ESCape to continue.", GWASKCOLOR, 15)
GWARRBROWSE AT 3,5,11,72 ARRAY GWDBF2Array(aFields) RESTORE VERTICAL ;
	TITLES aFields HELPLINE
GWRestScreen(aScreen)

aScreen := GWMessage("Now the structure of all open database files is shown. The structure array is created with GWDBStruct(). Press ESCape to continue.", GWASKCOLOR, 15)
GWARRBROWSE AT 3,5,11,72 ARRAY GWDBStruct(2) RESTORE VERTICAL HELPLINE ;
	TITLES {"Name", "Type", "Length", "Decimals", "Workarea", "Alias"}
GWRestScreen(aScreen)

DBCLOSEALL()

SETKEY(K_ALT_O, NIL)

RETURN(NIL)

******************************************************************************
*    Function : uPd1c3()                                                     *
* Description : Demo Database functions, LABEL ...                           *
*                                                                            *
*   Functions : LABEL ... command                                            *
*                                                                            *
* Date / time : 03-06-94 20:23                                               *
******************************************************************************
STATIC FUNCTION uPd1c3()
LOCAL aFields, aScreen

GWStatusLine("Demo GhostWare Library, simple reporting with LABEL command",0)

// Open the files and set a relation
//
// Database File: GENRE.DBF
//
// Field  FieldName  Type  Width  Decimals
//        
//   1    CODE        N      2       0
//   2    TEXT        C     14       0
//
GWNetUse("GENRE", "GENRE", "S", "N", 5)

//
// Database File: CD.DBF
//
// Field  FieldName  Type  Width  Decimals
//        
//   1    GROUP       C     16       0
//   2    TITLE       C     25       0
//   3    YEAR        N      4       0
//   4    GENRE       N      4       0
//   5    SONGS       N      2       0
//
GWNetUse("CD", , "S", "N", 5)
DBSETRELATION("GENRE", {|| CD->GENRE })

SET ALTERNATE TO GENRE.LST
SET ALTERNATE ON
SET CONSOLE OFF

// Make a simple report
?"Fancy title"
?"==========="
LABEL CD->GROUP,                       ; // Label line 1
      CD->TITLE,                       ;
			"Released  : "+STR(CD->YEAR,4),  ;
			"No. songs : "+STR(CD->SONGS,4), ;
			GENRE->TEXT,                     ;
			REPL("-", 25)                    ; // Label line 6
	    WIDTH 25 HORIZONTAL 1 VERTICAL 0 LEFTMARGIN 0 COLUMNS 3
SET CONSOLE ON
SET ALTERNATE OFF
CLOSE ALTERNATE
DBCLOSEALL()

GWTXTBROWSE ;
	FILE "GENRE.LST" ;                 // File to browse
	RESTORE                            // Restore screen after exit

RETURN(NIL)

******************************************************************************
*    Function : uPd1c4()                                                     *
* Description : Demo Database functions, sTatistics                          *
*                                                                            *
*   Functions : GWq...()                                                     *
*                                                                            *
* Date / time : 03-06-94 20:56                                               *
******************************************************************************
STATIC FUNCTION uPd1c4()
LOCAL aFields, aScreen

GWStatusLine("Demo GhostWare Library, simple statistics",0)

// Open the files and set a relation
//
// Database File: GENRE.DBF
//
// Field  FieldName  Type  Width  Decimals
//        
//   1    CODE        N      2       0
//   2    TEXT        C     14       0
//
GWNetUse("GENRE", "GENRE", "S", "N", 5)

//
// Database File: CD.DBF
//
// Field  FieldName  Type  Width  Decimals
//        
//   1    GROUP       C     16       0
//   2    TITLE       C     25       0
//   3    YEAR        N      4       0
//   4    GENRE       N      4       0
//   5    SONGS       N      2       0
//
GWNetUse("CD", "CD", "S", "N", 5)
DBSETRELATION("GENRE", {|| CD->GENRE })

STATISTIC TO FILE QUERY BREAK ON CD->GENRE
STATISTIC LABEL GENRE->TEXT TO "GENRE"
STATISTIC COUNT TO "COUNT" LENGTH 5
STATISTIC SUM CD->SONGS TO "SONGS" LENGTH 5
STATISTIC GO COUNTER TOTALS

GWNetUse("QUERY", , "S", "N", 5)
GWDBFBROWSE ;
	FIELDS {"GENRE","COUNT", "SONGS"} ;  // Fields to browse
	RESTORE                              // Restore screen after exit

DBCLOSEALL()

RETURN(NIL)

******************************************************************************
*    Function : uPd1d1()                                                     *
* Description : Demo DOS functions/Check for drives                          *
*                                                                            *
*   Functions : GWIsValid()                                                  *
*                                                                            *
* Date / time : 11-10-93 12:24                                               *
******************************************************************************
STATIC FUNCTION uPd1d1()

LOCAL aScreen, cOldColor := SETCOLOR(GETCOLOR), cDrive, aResult
LOCAL nT:=2, nL:=1, nB:=15, nR:=76, nChar:=67, nRow:=1, nCol:=3

GWStatusLine("Demo GhostWare Library MISCELLANEOUS functions",0)
GWStatusLine("GWIsValid()",24)

aScreen := GWShadowBox(nT, nL, nB, nR, GWcString("GETSTANDARD"))

@nT, nL+1 SAY IIF(GWUseSpecial()," Check for existence of drives "," Check for existence of drives ")

DO WHILE nChar<=90                    // Check drives C to Z
	cDrive := CHR(nChar)+":"
	aResult := GWIsValid(cDrive,,.F.)
	@nT+nRow, nL+nCol SAY cDrive + " " + IIF(aResult[1], "Drive found", aResult[3])
	++nChar
	++nRow
	IF nRow>=nB-nT
		nRow := 1
		nCol := nCol+36
	ENDIF
ENDDO

GWAsk("Drives C: to Z: checked",,,GWASKCOLOR,,17)

GWRestScreen(aScreen)

RETURN(NIL)

******************************************************************************
*    Function : uPd1d4()                                                     *
* Description : Demo DOS functions/Get tree information                      *
*                                                                            *
*   Functions : -                                                            *
*                                                                            *
* Date / time : 11-10-93 21:32                                               *
******************************************************************************
STATIC FUNCTION uPd1d4()

LOCAL aTree := GWGetTree("\", .T., .T., .T.), aResult

GWArrBrowse ARRAY aTree[2] COUNTER VERTICAL RESTORE VAR aResult ENTERISCHOICE

IF LASTKEY() == K_ENTER
	GWASK("Selected directory : "+aTree[1, aResult[1], 1])
ENDIF

RETURN(NIL)

******************************************************************************
*    Function : uPd1d5()                                                     *
* Description : Demo DOS functions/Other DOS functions                       *
*                                                                            *
*   Functions : -                                                            *
*                                                                            *
* Date / time : 11-10-93 21:31                                               *
******************************************************************************
STATIC FUNCTION uPd1d5()

LOCAL cText

GWStatusLine("Demo GhostWare Library MISCALLENEOUS functions",0)
cText := "other GhostWare Library MISCELLANEOUS functions :"+GWCRLF()+GWCRLF()
cText += "GWCopyFile()  - Copy 1 or more files"+GWCRLF()
cText += "GWGetDir()    - Get directory information"+GWCRLF()
cText += "GWIsRAMDisk() - Check if there is a RAM disk "+ ;
	IIF(GWIsRAMDisk(),"(There is one in this machine)","(No RAMDisk in this machine)")+GWCRLF()
cText += "GWChDir()     - Change directory"+GWCRLF()
cText += "GWMkDir()     - Make directory"+GWCRLF()
cText += "GWRmDir()     - Remove directory"+GWCRLF()
cText += "GWRestEnv()   - Restore the OS environment"+GWCRLF()
cText += "GWSaveEnv()   - Save the OS environment"+GWCRLF()
cText += "GWSize()      - Determine the size of a file"+GWCRLF()
cText += "GWWaitkey()   - Replacement for INKEY()"

GWAsk(cText,,,GWASKCOLOR,,2)

RETURN(NIL)

******************************************************************************
*    Function : uPd1e1()                                                     *
* Description : Demo Getlist functions, Functions demo                       *
*                                                                            *
*   Functions : GWCalender(), GWCheckBoxes(), GWPostPick(), GWPrePick(),     *
*                                                                            *
* Date / time : 27-01-93 22:20                                               *
******************************************************************************
STATIC FUNCTION uPd1e1(lMouse)

LOCAL aScreen, cOldColor := SETCOLOR(GETCOLOR)
LOCAL nT:=1, nL:=9, nB:=20, nR:=69, GETLIST:={}
LOCAL cValue1, cValue2, cPassword, cInitials, dDate:=LEGEDATUM, nNum:=0, cCheck, cRadio
LOCAL cMemo1:="Press Alt-A, great hey!", cMemo2:="The above window shows the text from the first GET MEMO field."
LOCAL lBut1:=.F., lBut2:=.F.

COOL ALL HOTSPOTS
GWStatusLine("Demo GhostWare Library GETLIST functions",0)

IF lMouse
	GWStatusLine("Move your mouse to any GET and click, in a GET you can mouse to any position",MAXROW())
ENDIF
DO WHILE .T.
	IF aScreen != NIL
		GWRestScreen(aScreen)
	ENDIF

	aScreen := GWShadowBox(nT, nL, nB, nR, SETCOLOR(), 1)
	cValue1   := "         "
	cValue2   := "         "
	cPassword := "         "
	cInitials := "         "
	@nT+1,nL+3 SAY "GWPostPick() demo (type in the right word) :" GET cValue1 ;
		VALID GWPostPick("GWPostPick() discovered an error in your response, so choose one of these words",{"GhostWare","Library","Is","Great!"})
	@nT+2,nL+3 SAY "GET ... PICK                               :" GET cValue2 ;
		PICK {"GhostWare","Library","Is","The","Best!"} QUESTION "GET PICK let you pick an answer"
	@nT+3,nL+3 SAY "GET ... CALENDER (use ALT-K)               :" GET dDate CALENDER
	@nT+4,nL+3 SAY "GET ... CALCULATOR (use ALT-K)             :" GET nNum  CALCULATOR PICTURE "######.#"
	@nT+5,nL+3 SAY "GET ... PASSWORD                           :" GET cPassword PASSWORD
	@nT+6,nL+3 SAY "GET ... INITIALS (type 'th.e.o.')          :" GET cInitials INITIALS
	@nT+8, nL+3 SAY "GET ... CHECKBOX :"
	@nT+9, nL+3 GET cCheck CHECKBOX {"Box 1","Box 2","Box 3"}
	@nT+8, nL+25 SAY "GET ... RADIO :"
	@nT+9, nL+25 GET cRadio RADIO {"Radio 1","Radio 2","Radio 3"}
	@nT+13, nL+3 SAY "GET MEMO 1 :" GET MEMO cMemo1 AT nB-4,nL+2,nB+2,nR-2 ;
		KEY {K_ALT_E,"Alt-E"} TITLE "First note"
	@nT+14, nL+3 SAY "GET MEMO 2 :" GET MEMO cMemo2 AT nB-4,nL+2,nB+2,nR-2 ;
		TITLE "Second note" BLOCK {|| GWMemoDisplay(cMemo1,nB-10,nL+4,nB-6,nR-4,"Displayed with GWMemoDisplay()",GWEnhanced()) }
	@nT+16, nL+3  GET lBut1 BUTTON "Again"  DO GWAsk("You pressed the 'Again' button.")  EXITREAD
	@nT+16, nL+13 GET lBut2 BUTTON "Cancel" DO GWAsk("You pressed the 'Cancel' button.") EXITREAD
	@nT+18, nL+3 SAY "Another great getlist command is '@...GET...HISTORY [n]'."
	READ

	IF LASTKEY()==K_ESC
		EXIT
	ENDIF

	IF lBut2                             // Cancel button is pressed
		EXIT
	ENDIF

ENDDO

GWRestScreen(aScreen)
WARM ALL HOTSPOTS

SETCOLOR(cOldColor)

RETURN(NIL)

******************************************************************************
*    Function : uPd1e2()                                                     *
* Description : Demo Getlist functions, Getsys changes                       *
*                                                                            *
*   Functions : -                                                            *
*                                                                            *
* Date / time : 27-01-93 22:20                                               *
******************************************************************************
STATIC FUNCTION uPd1e2()

LOCAL cText

GWStatusLine("Changes in CA-Clipper GETSYStem",0)

cText := "The following changes are made :"+GWCRLF()+GWCRLF()
cText += "- ASCII-characters above 128 can be typed in;"+GWCRLF()
cText += "- the cursor size shows that characters will be inserted () or will be overwritten (_);"+GWCRLF()
cText += "- the cursor is turned on (_) when the GETlist is activated and will be restored to it's original size after leaving the GETlist;"+GWCRLF()
cText += "- after pressing the ALT-A keys in a field, a ASCII-table is displayed."

GWAsk(cText,,,GWASKCOLOR,,5)

RETURN(NIL)

******************************************************************************
*    Function : uPd1f1()                                                     *
* Description : Demo LOG functions                                           *
*                                                                            *
*   Functions : GWErrorlog(), GWLogin(), GWUserlog(), GWUsers()              *
*                                                                            *
* Date / time : 01-02-93 20:33                                               *
******************************************************************************
STATIC FUNCTION uPd1f1()

LOCAL cText

GWStatusLine("Demo GhostWare Library functions for LOGGING",0)
cText := "GhostWare Library functions for LOGGING :"+GWCRLF()+GWCRLF()
cText += "GWChangePassword() - Change the password stored in the login file. The password stored decrypted."+GWCRLF()+GWCRLF()
cText += "GWErrorlog()       - View the error recording files ERRORLOG and TRACE. These files contain information about runtime error. This makes it easy to debug your application."+GWCRLF()+GWCRLF()
cText += "GWLogin()          - Procedure to log into a network application. This functions registers logging on and off your application."+GWCRLF()+GWCRLF()
cText += "GWUserlog()        - View the USERLOG that contains information about the use of your application. The file is filled by the GWLOGIN() function."+GWCRLF()+GWCRLF()
cText += "GWUsers()          - Contains information about the users that may use your application via the GWLOGIN() function."

GWAsk(cText,,,GWASKCOLOR,,1)

RETURN(NIL)

******************************************************************************
*    Function : uPd1g1()                                                     *
* Description : Demo MENU functions                                          *
*                                                                            *
*   Functions : GWAsk(), GWMenuArray(), GWPdown()                            *
*                                                                            *
* Date / time : 01-02-93 20:54                                               *
******************************************************************************
STATIC FUNCTION uPd1g1()

LOCAL cText

GWStatusLine("Demo GhostWare Library functions for MENUS",0)
cText := "GhostWare Library functions for MENUS :"+GWCRLF()+GWCRLF()
cText += "GWAsk()       - This window is made with this function. You can create horizontal or vertical menus, change colors, borders and so on."+GWCRLF()+GWCRLF()
cText += "GWMenuArray() - Create a nested array from a DBF to be used in the GWPdown() function."+GWCRLF()+GWCRLF()
cText += "GWPdown()     - Create a pulldown system like the one used in this demo."+GWCRLF()+GWCRLF()
cText += "MENU Commands - Commands for creating pulldown menu's easily. See lines 58 to 148 of this program."

GWAsk(cText,,,GWASKCOLOR,,3)

RETURN(NIL)

******************************************************************************
*    Function : uPd1h1()                                                     *
* Description : Demo Mouse functions, GWmDirection()/GWmInArea()             *
*                                                                            *
*   Functions : -                                                            *
*                                                                            *
* Date / time : 01-02-93 21:24                                               *
******************************************************************************
STATIC FUNCTION uPd1h1()

LOCAL aScreen, cOldColor := SETCOLOR(GETCOLOR)
LOCAL nT:=6, nL:=5, nB:=22, nR:=75
LOCAL aHelp:={.F.,.F.,0,0}, lHelp:=.F.
LOCAL aMotion:={0,0}

COOL ALL HOTSPOTS                      // Turn all hotspots off
GWStatusLine("Demo GhostWare Library MOUSE functions",0)

aScreen := GWShadowBox(nT, nL, nB, nR, SETCOLOR(), 1)
@8,25 TO 11,55                        // Draw single border
@9,27 SAY  "      Mouse row :"
@9,11 SAY  "   GWmRow() >"
@10,27 SAY "   Mouse column :"
@10,11 SAY "   GWmCol() >"
@12,25 TO 14,55                        // Draw single border
@13,27 SAY " Last direction :"
@13,11 SAY "GWmMotion() >"
@17,11 SAY "GWmInArea() >"
@8,57 TO 11,70                        // Draw single border
@9,59 SAY  "click here"
@10,59 SAY " to EXIT"
@15,25 TO 19,55                    // Draw single border
@21,nL+3 SAY  "PS. GWmRange() is used to keep the mouse cursor in this window!"
GWmRange(nT, nL, nB, nR)

DO WHILE .T.
	// If left button is pressed in EXIT-box then leave this demo
	IF aHelp[1] .and. GWmInArea(9,58,10,69)
		EXIT
	ENDIF

	IF lHelp .and. GWmInArea(16,26,18,54)// Inside the box
		@17,29 SAY '  Get out of this box '
		lHelp:=.F.
	ELSEIF !lHelp .and. !GWmInArea(16,26,18,54)
		@17,29 SAY 'Move mouse in this box'
		lHelp:=.T.
	ENDIF
	aHelp[1] := .F.
	aMotion  := {0,0}
	DO WHILE aMotion[1]+aMotion[2]=0 .AND. !aHelp[1]
		GWmRead(aHelp)                     // Read mouse status and position
		GWmMotion(aMotion)                 // Read motion of mouse cursor
	ENDDO
	IF aMotion[1]>0                      // Move down
		@13,45 SAY REPLICATE(CHR(25),9)
	ELSEIF aMotion[1]<0                  // Move up
		@13,45 SAY REPLICATE(CHR(24),9)
	ELSEIF aMotion[2]<0                  // Move left
		@13,45 SAY REPLICATE(CHR(27),9)
	ELSEIF aMotion[2]>0                  // Move right
		@13,45 SAY REPLICATE(CHR(26),9)
	ENDIF

	@9,45 SAY STR(aHelp[3],2)            // Cursor row
	@10,45 SAY STR(aHelp[4],2)           // Cursor column
ENDDO
GWmRange()                             // Set range to entire screen

GWRestScreen(aScreen)

WARM ALL HOTSPOTS                      // Turn all hotspots on
SETCOLOR(cOldColor)

RETURN(NIL)

******************************************************************************
*    Function : uPd1i1()                                                     *
* Description : Demo MISCELLANEOUS functions/Browse an array                 *
*                                                                            *
*   Functions : GWBrowseArray()                                              *
*                                                                            *
* Date / time : 02-02-93 20:56                                               *
******************************************************************************
STATIC FUNCTION uPd1i1()

LOCAL aScreen, Getlist:={}, cDir:=SPACE(100) , aDir, cExclude:=SPACE(100), aExclude, aFiles
LOCAL cKind:="H", cSort:="N", cAsDes:="A"


GWStatusLine("Demo GhostWare Library MISCELLANEOUS functions",0)
GWStatusLine("GWGetDir() and GWBrowseArray()",24)

aScreen := GWShadowBox(8, 5, 18, 73, 'W+/B')
@ 9,7 SAY 'Directory of  (*:' COLOR 'W+/B' GET cDir picture '@S47 '+repl('!',100) COLOR 'W+/R'
@10,7 SAY 'Exclude files (*:' COLOR 'W+/B' GET cExclude picture '@S47 '+repl('!',100) COLOR 'W+/R'

@12,7 SAY "Files included :" COLOR 'W+/B'
@13,7 GET cKind CHECKBOX {"Hidden","System","Directory"} CHECKCOLOR "W+/R,W+/G" ANSWERS {"H","S","D"}

@12,30 SAY "Sort on :" COLOR 'W+/B'
@13,30 GET cSort RADIO {"Name","Size","Date"} RADIOCOLOR "W+/R,W+/G" ANSWERS {"N","S","D"}
@12,53 SAY "Sort order :" COLOR 'W+/B'
@13,53 GET cAsDes RADIO {"Ascending","Descending"} RADIOCOLOR "W+/R,W+/G" ANSWERS {"A","D"}

@17,7 SAY "(* syntax : <spec>,..,<spec> e.g. D:\*.COM,C:\*.EXE" COLOR "W+/B"
READ
GWRestScreen(aScreen)
IF LASTKEY()!=K_ESC
	cDir := IIF(cDir==Space(100), "*.*", cDir)
	aDir := GWString2Array(cDir, ",")
	aExclude := GWString2Array(cExclude, ",")

	// Sort aFiles on Name, Size or Date
	aFiles := GWGetDir(aDir, aExclude, cKind, cSort, cAsDes)

	aScreen := GWSaveScreen(0, 0, 24, 79)

	GWARRBROWSE AT 3,8,20,70 ARRAY aFiles TITLES {"File","Size","Date","Time","Attrib"} COUNTER VERTICAL

	GWRestScreen(aScreen)
ENDIF

RETURN(NIL)

******************************************************************************
*    Function : uPd1i2()                                                     *
* Description : Demo MISCELLANEOUS functions/Browse a textfile               *
*                                                                            *
*   Functions : GWBrowseText()                                               *
*                                                                            *
* Date / time : 02-02-93 22:17                                               *
******************************************************************************
STATIC FUNCTION uPd1i2()

GWStatusLine("Demo GhostWare Library MISCELLANEOUS functions",0)
GWStatusLine("GWBrowseText()",24)

GWTXTBROWSE FILE "GW_DEMO.PRG" AT 3,3,20,74 LINENUM RESTORE

RETURN(NIL)

******************************************************************************
*    Function : uPd1i4()                                                     *
* Description : Demo MISCELLANEOUS functions/Other misc. functions           *
*                                                                            *
*   Functions : -                                                            *
*                                                                            *
* Date / time : 03-02-93 09:10                                               *
******************************************************************************
STATIC FUNCTION uPd1i4()

LOCAL cText

GWStatusLine("Demo GhostWare Library MISCALLENEOUS functions",0)
cText := "other GhostWare Library MISCELLANEOUS functions :"+GWCRLF()+GWCRLF()
cText += "GWCrLf()        - Returns a carriage return and line feed string"+GWCRLF()
cText += "GWDelay()       - Wait for a certain period"+GWCRLF()
cText += "GWFakeKey()     - Change te action of a key"+GWCRLF()
cText += "GWHelp()        - Activate the GhostWare helpsystem"+GWCRLF()
cText += "GWKeyBoard()    - Stuff a key value into the keyboard buffer"+GWCRLF()
cText += "GWMemoDisplay() - Display a long string"+GWCRLF()
cText += "GWMemoEdit()    - Display or edit a long string"+GWCRLF()
cText += "GWMusic()       - Play some tones"+GWCRLF()
cText += "GWRandom()      - Generate a random number"+GWCRLF()
cText += "GWKeyBoard()    - Stuff a key value into the keyboard buffer"+GWCRLF()
cText += "GWPassword()    - Ask an user for a password"+GWCRLF()
cText += "GWTrace()       - View the program call stack"+GWCRLF()
cText += "GWWaitkey()     - Replacement for INKEY()"

GWAsk(cText,,,GWASKCOLOR,,2)

RETURN(NIL)

******************************************************************************
*    Function : uPd1j1()                                                     *
* Description : Demo PRINTER functions                                       *
*                                                                            *
*   Functions : -                                                            *
*                                                                            *
* Date / time : 03-02-93 20:44                                               *
******************************************************************************
STATIC FUNCTION uPd1j1()

LOCAL cText

GWStatusLine("Demo GhostWare Library PRINTER functions",0)
cText := "GhostWare Library PRINTER functions :"+GWCRLF()+GWCRLF()
cText += "The library contains over 13 functions to control a HP compatible Laserprinter."+GWCRLF()+GWCRLF()
cText += "Furthermore there are functions to format your output. Read the Norton Guide supplied with this library for more information."

GWAsk(cText,,,GWASKCOLOR,,6)

RETURN(NIL)

******************************************************************************
*    Function : uPd1k1()                                                     *
* Description : Demo SCREEN functions / Clear the screen                     *
*                                                                            *
*   Functions : GWClearScreen()                                              *
*                                                                            *
* Date / time : 03-02-93 20:56                                               *
******************************************************************************
STATIC FUNCTION uPd1k1()

LOCAL aScreen, cOldColor := SETCOLOR(GETCOLOR), Getlist:={}
LOCAL nT:=4, nL:=4, nB:=6, nR:=72, cClearChar:='         '

GWStatusLine("Demo GhostWare Library SCREEN functions",0)
GWStatusLine("GWClearScreen()",24)

DO WHILE .T.
	aScreen := GWShadowBox(nT, nL, nB, nR)
	@nT+1, nL+3 SAY 'What character(s) must be used to clear the screen :' GET cClearChar
	READ

	GWRestScreen(aScreen)
	GWClearScreen(,RTRIM(cClearChar))

	IF GWAsk("Again?",{"Yes","No"},,GWASKCOLOR,,7)==2
		EXIT
	ENDIF
ENDDO

SETCOLOR(cOldColor)

RETURN(NIL)

******************************************************************************
*    Function : uPd1k2()                                                     *
* Description : Demo SCREEN functions / Display a message                    *
*                                                                            *
*   Functions : GWMessage()                                                  *
*                                                                            *
* Date / time : 03-02-93 21:52                                               *
******************************************************************************
STATIC FUNCTION uPd1k2()

LOCAL aScreen:=ARRAY(10), i

GWStatusLine("Demo GhostWare Library SCREEN functions",0)
GWStatusLine("Study the shadows carefully : this is REAL shadowing!!!",24)

aScreen[1] := GWMessage("GWMessage() box 1", "W+/B", 4, 30,B_ZEER_VET+" ")
aScreen[2] := GWMessage("GWMessage() box 2", "GR+/R", 3, 55)
aScreen[3] := GWMessage("GWMessage() box 3", "G+/G", 18, 27,B_SINGLE+" ")
aScreen[4] := GWMessage("GWMessage() box 4", "N*/W", 12, 35,B_ZEER_VET+" ")
aScreen[5] := GWMessage("GWMessage() box 5", "GR+/G",16, 48,B_SINGLE+" ")
aScreen[6] := GWMessage("GWMessage() box 6", "B*/G", 17, 12)
aScreen[7] := GWMessage("GWMessage() box 7", "W+/G", 2, 10,B_SINGLE+" ")
aScreen[8] := GWMessage("GWMessage() box 8", "GR*/BG", 9, 52)
aScreen[9] := GWMessage("GWMessage() box 9", "N*/RB", 11, 5,B_SINGLE+" ")
aScreen[10] := GWMessage("GWMessage() box 10", "W*/GR", 6, 2,B_ZEER_VET+" ")

GWAsk("Continue?",{"Yes"},,GWASKCOLOR,,7)

FOR i := 10 TO 1 STEP -1
	GWRestScreen(aScreen[i], .T.)
NEXT

RETURN(NIL)

******************************************************************************
*    Function : uPd1k3()                                                     *
* Description : Demo SCREEN functions / Screensavers                         *
*                                                                            *
*   Functions : GWBlockDrop(), GWMagic, GWShuffle(), GWStars()               *
*                                                                            *
* Date / time : 25-03-93 20:20                                               *
******************************************************************************
STATIC FUNCTION uPd1k3()

LOCAL aScreen:=ARRAY(3), nSaver

GWStatusLine("Demo GhostWare Library SCREEN functions",0)
GWStatusLine("Screensavers GWBlockDrop, GWMagic, GWShuffle, GWWeave",24)

aScreen[1] := GWMessage(" G h o s t W a r e Screensavers demo  ", "W+/B", 3, 5,B_ZEER_VET+" ")
aScreen[2] := GWMessage(" G h o s t W a r e Screensavers demo  ", "R*/GR",10, 18,B_ZEER_VET+" ")
aScreen[3] := GWMessage(" G h o s t W a r e Screensavers demo  ", "N*/RB",17, 31,B_ZEER_VET+" ")

DO WHILE .T.

	nSaver:=GWAsk("Which screensaver do you want to see?",{"GWBlockDrop()","GWMagic()","GWShuffle()","GWWeave()","none"},,GWASKCOLOR,,7)

	DO CASE
		CASE nSaver==1
			GWBlockDrop({|| GWAsk("This box is shown every 15 seconds!") }, 15)
		CASE nSaver==2
			GWMagic({|| GWAsk("This box is shown every 15 seconds!") }, 15)
		CASE nSaver==3
			GWShuffle({|| GWAsk("This box is shown every 15 seconds!") }, 15)
		CASE nSaver==4
			GWWeave({|| GWAsk("This box is shown every 15 seconds!") }, 15)
		OTHERWISE
			EXIT
	ENDCASE

ENDDO

GWRestScreen(aScreen[3], .T.)
GWRestScreen(aScreen[2], .T.)
GWRestScreen(aScreen[1], .T.)

RETURN(NIL)

******************************************************************************
*    Function : uPd1k4()                                                     *
* Description : Demo SCREEN functions / Spinning the screen                  *
*                                                                            *
*   Functions : GWSpin()                                                     *
*                                                                            *
* Date / time : 04-02-93 21:57                                               *
******************************************************************************
STATIC FUNCTION uPd1k4()

LOCAL cOldColor := SETCOLOR(GETCOLOR), Getlist:={}
LOCAL nT:=4, nL:=20, nB:=9, nR:=58, aScreen:=ARRAY(4)
LOCAL nSpins:=1, nSpeedFrom:=0, nSpeedTo:=0.2, nStep:=0.05

GWStatusLine("Demo GhostWare Library SCREEN functions",0)
GWStatusLine("GWSpin()",24)

aScreen[1] := GWMessage(" G h o s t W a r e Spin demo  ", "W+/B", 3, 5,B_ZEER_VET+" ")
aScreen[2] := GWMessage(" G h o s t W a r e Spin demo  ", "R*/GR",10, 20,B_ZEER_VET+" ")
aScreen[3] := GWMessage(" G h o s t W a r e Spin demo  ", "N*/RB",17, 35,B_ZEER_VET+" ")

DO WHILE .T.
	aScreen[4] := GWShadowBox(nT, nL, nB, nR)
	@nT+1, nL+3 SAY 'Number of spins :' GET nSpins
	@nT+2, nL+3 SAY 'Staring speed   :' GET nSpeedFrom
	@nT+3, nL+3 SAY 'Ending speed    :' GET nSpeedTo
	@nT+4, nL+3 SAY 'Step size       :' GET nStep
	READ

	GWRestScreen(aScreen[4], .T.)

	GWSpin(10,20,15,56,,nSpins, nSpeedFrom, nSpeedTo, nStep)

	IF GWAsk("Again?",{"Yes","No"},,GWASKCOLOR,,7)==2
		EXIT
	ENDIF
ENDDO

GWRestScreen(aScreen[3], .T.)
GWRestScreen(aScreen[2], .T.)
GWRestScreen(aScreen[1], .T.)

RETURN(NIL)

******************************************************************************
*    Function : uPd1k5()                                                     *
* Description : Demo SCREEN functions / Other functions                      *
*                                                                            *
*   Functions : -                                                            *
*                                                                            *
* Date / time : 05-02-93 19:34                                               *
******************************************************************************
STATIC FUNCTION uPd1k5()

LOCAL cText, aScreen, aStatusBar
LOCAL nCount := 0

GWStatusLine("Demo GhostWare Library SCREEN functions",0)
cText := "other GhostWare Library SCREEN functions :"+GWCRLF()+GWCRLF()
cText += "GWExplode()     - Display an exploding box"+GWCRLF()
cText += "GWRestScreen()  - Restore a (part of the) screen"+GWCRLF()
cText += "GWSaveScreen()  - Save a (part of the) screen"+GWCRLF()
cText += "GWScreen2File() - Save a screen to a textfile"+GWCRLF()
cText += "GWShowlogo()    - Show 1 (or 2) intro screens"+GWCRLF()
cText += "GWStatusBar()   - Show a statusbar"+GWCRLF()
cText += "GWStatusLine()  - Show a centered message"+GWCRLF()
cText += "GWWatch()       - Show a watch"
GWStatusLine("This message is made with GWStatusLine()")

aScreen := GWMessage(cText, "W+/B", 1)

aStatusBar := GWStatusBar("This Statusbar is made with GWStatusBar()",16,"GR+/R")
DO WHILE nCount<=100
	GWStatusBar(nCount,16,"W+/R")
	GWDelay(0.05)
	++nCount
ENDDO

GWAsk("Ready?",,,GWASKCOLOR,, 8,3)

GWRestScreen(aStatusBar, .T.)
GWRestScreen(aScreen)

RETURN(NIL)

******************************************************************************
*    Function : uPd1l1()                                                     *
* Description : Video functions / Character redefinition and so on           *
*                                                                            *
* Date / time : 28-10-93 20:19                                               *
******************************************************************************
STATIC FUNCTION uPd1l1()

LOCAL cText

GWStatusLine("Demo GhostWare Library VIDEO functions, character redefinition and so on",0)
cText := "GWIsCGA()      - Check if CGA adapter is available"+GWCRLF()
cText += "GWIsEGA()      - Check if EGA adapter is available"+GWCRLF()
cText += "GWIsMono()     - Check if monochroom adapter is available"+GWCRLF()
cText += "GWIsVGA()      - Check if VGA adapter is available"+GWCRLF()
cText += "GWLoadFont()   - Load 1 or more character designs into a font block"+GWCRLF()
cText += "GWReadFont()   - Read a font file and load it in a block"+GWCRLF()
cText += "GWResetFont()  - Reset the redefined font to default PC font"+GWCRLF()
cText += "GWScanLines()  - Determine the number of scanlines per character"+GWCRLF()
cText += "GWUseFonts()   - Define which font blocks should be used"+GWCRLF()
cText += "GWUseSpecial() - Get/set the usage of the GhostWare special character set"+GWCRLF()
cText += "GWVideo()      - Check which video adapter is available"

GWAsk(cText,,,GWASKCOLOR,,4)

RETURN(NIL)

******************************************************************************
*    Function : uPd1l2()                                                     *
* Description : Video functions / RGB color redefinition                     *
*                                                                            *
* Date / time : 10-11-93 20:47                                               *
******************************************************************************
STATIC FUNCTION uPd1l2()

LOCAL cText

GWStatusLine("Demo GhostWare Library VIDEO functions, RGB color redefinition",0)
cText := "GWAllVGAColors() - Change the RGB definitions of all 16 colors"+GWCRLF()
cText += "GWDisableColor() - Dosable color redefinition"+GWCRLF()
cText += "GWEnableColor()  - Enable color redefinition"+GWCRLF()
cText += "GWEnabled()      - Check if color redefinition is enabled"+GWCRLF()
cText += "GWModColor()     - Modify the RGB values of the 16 VGA colors"+GWCRLF()
cText += "GWVGAColor()     - Change the definition of a color"

GWAsk(cText,,,GWASKCOLOR,,4)

RETURN(NIL)

******************************************************************************
*    Function : uPd2a1()                                                     *
* Description : About / GhostWare Library                                    *
*                                                                            *
* Date / time : 05-02-93 20:01                                               *
******************************************************************************
STATIC FUNCTION uPd2a1()

LOCAL cText

GWStatusLine("About / GhostWare Library",0)
cText := "GhostWare Library is written by :"+GWCRLF()+GWCRLF()
cText += "   Ren van Geest"+GWCRLF()
cText += "   Edelsteenweg 57"+GWCRLF()
cText += "   2651 SP Berkel & Rodenrijs"+GWCRLF()
cText += "   Holland"+GWCRLF()+GWCRLF()
cText += "For question, remarks, complaints, compliments, comments, suggestions, "
cText += "wishes, updates, contributions and so on, you can always contact me."

GWAsk(cText,,,GWASKCOLOR,,4)

RETURN(NIL)

******************************************************************************
*    Function : uPd2a2()                                                     *
* Description : About / Benifits of registering                              *
*                                                                            *
* Date / time : 05-02-93 20:22                                               *
******************************************************************************
STATIC FUNCTION uPd2a2()

LOCAL cText

GWStatusLine("Benefits of registering GhostWare Library",0)
cText := "Benefits of registering GhostWare Library :"+GWCRLF()+GWCRLF()
cText += "- receive the latest version;"+GWCRLF()
cText += "- receive Dutch and American GhostWare Libraries;"+GWCRLF()
cText += "- receive complete Norton Guide (over 450K);"+GWCRLF()
cText += "- receive notification of new versions;"+GWCRLF()
cText += "- get support;"+GWCRLF()
cText += "- being legal."+GWCRLF()+GWCRLF()
cText += "So, register for only 35,- (in Holland or $30,- elsewhere)."+GWCRLF()
cText += "Also read the READ.ME file."+GWCRLF()

GWAsk(cText,,,GWASKCOLOR,,4)

RETURN(NIL)

******************************************************************************
*    Function : uPd2a3()                                                     *
* Description : About / Read the READ.ME file                                *
*                                                                            *
* Date / time : 16-02-93 21:41                                               *
******************************************************************************
STATIC FUNCTION uPd2a3()

GWStatusLine("GhostWare Library READ.ME file",0)

GWTXTBROWSE FILE "READ.ME" AT 3,3,21,74 RESTORE

RETURN(NIL)
