/*
    The source code contained within this file is protected under the
    laws of the United States of America and by International Treaty.
    Unless otherwise noted, the source contained herein is:

    Copyright (c)1990, 1991, 1992 BecknerVision Inc - All Rights Reserved

    Written by John Wm Beckner        THIS NOTICE MUST NOT BE REMOVED
    BecknerVision Inc
    PO Box 11945                      SOURCE CODE (THIS FILE) MAY NOT BE
    Winston-Salem NC 27116            DISTRIBUTED!  ONLY REGISTERED USERS
    Fax: 919/760-1003                 OF BECKNER LIBRARY & UTILITIES II MAY
                                      BE IN POSSESSION OF THIS FILE.
*/

#include "beckner.inc"

FUNCTION iMouse(nOption, aData)
   STATIC lInit := .n., nButtons := 0, nColMin := 0, nRowMin := 0
   STATIC nColMax, nRowMax
   LOCAL nScrMode, aReturn
   DEFAULT nColMax TO MaxCol(), nRowMax TO MaxRow()
   IF nOption=NIL .or. (nOption!=1 .and. !lInit)
      RETURN 0
   ENDIF
   IF nOption=1
      nButtons := amInit()
      iif(nButtons>0, lInit := .y.,)
      RETURN lInit
   ENDIF
   IF nOption=2
      RETURN nButtons
   ENDIF
   IF nOption=3
      nScrMode := avScreenMode()
      DO CASE
      CASE nScrMode<2
         aData[1] *= 8
         aData[2] *= 16
      CASE nScrMode<4
         aData[1] *=8
         aData[2] *=8
      ENDCASE
      RETURN aData
   ENDIF
   IF nOption=4
      aReturn := {nRowMin, nColMin, nRowMax, nColMax}
      IF aData!=NIL
         nRowMin := aData[1]
         nColMin := aData[2]
         nRowMax := aData[3]
         nColMax := aData[4]
      ENDIF
      RETURN aReturn
   ENDIF
   IF nOption=5
      nScrMode := avScreenMode()
      DO CASE
      CASE nScrMode<2
         aData[1] /= 8
         aData[2] /= 16
      CASE nScrMode<4
         aData[1] /=8
         aData[2] /=8
      ENDCASE
      RETURN aData
   ENDIF
   IF nOption=6
      RETURN lInit
   ENDIF
ENDFUNCTION
