/*
 * GT CLIPPER STANDARD HEADER
 *
 * File......: levensup.prg
 * Author....: Andy M Leighton
 * BBS.......: The Dark Knight Returns
 * Net/Node..: 050/069
 * User Name.: Andy Leighton
 * Date......: $Date$
 * Revision..: $Revision$
 *
 * This is an original work by Andy Leighton and is placed in the
 * public domain.
 *
 * Modification history:
 * ---------------------
 *
 * $Log$
 *
 */

#include "gt_LIB.ch"
#include "levensht.ch"

/*
 * support routines only
 * do not call gGT_Cost from your program
 */

static opTable := {                                ;
                     { 0, "EQU", -1, -1 },         ;
                     { 1, "INS",  0, -1 },         ;
                     { 1, "DEL", -1,  0 },         ;
                     { 1, "SUB", -1, -1 }          ;
                  }

/*
 * Support Function: gGT_Cost()
 *
 * get/set routine for accessing Cost in the opTable
 */

function gGT_Cost(op, nNewCost)

   local nCost := opTable[op][1]

   if nNewCost != NIL
      opTable[op][1] := nNewCost
   endif

return nCost

