/*
* Mouse.ch
*
* Constants for use with the mouse interface
*
*/
// You can use this statement when compiling with Clipper 5.2
#STDOUT Using MOUSE.CH    - version 2.3 by GhostWare (c) 1991-1994

//
// Defines for mouse sensitive GETs
// These are used by the GETSYS.PRG replacement GW_GET52.PRG
// and the additional GET readers like GET...BUTTON, GET...CALENDER,
// GET...CALCULATOR and so on.
//
#DEFINE GET_LEFT_PRESSED     -50       // Values to receive back from GWAction()
#DEFINE GET_RIGHT_PRESSED     27       //   when left or right button is pressed

#DEFINE GE_MOUSE              99       // Additional exit value for GETEXIT.CH
                                       // A high value is used so no conflicts with
                                       // the CA (future) exit codes will arise.


// MouseRead fills in an array of 4 elements, defined by
// the following manifest constants

#define M_LEFT_PRESSED   1
#define M_RIGHT_PRESSED  2
#define M_ROW            3
#define M_COL            4
#define M_SIZE_ARRAY     M_COL

#define MOUSE_DOWN(aInfo) (aInfo[M_LEFT_PRESSED] .OR. aInfo[M_RIGHT_PRESSED])

#XTRANSLATE Scroll([<parms,...>])     => MScroll(<parms>)
#XTRANSLATE SetMode([<parms,...>])    => MSetMode(<parms>)
#XTRANSLATE SaveScreen([<parms,...>]) => MSaveScreen(<parms>)
#XTRANSLATE RestScreen([<parms,...>]) => MRestScreen(<parms>)
#XTRANSLATE DevOut([<parms,...>])     => MDevOut(<parms>)
#XTRANSLATE QOut([<parms,...>])       => MQout({<parms>})
#XTRANSLATE DispBox([<parms,...>])    => MDispBox(<parms>)
#XTRANSLATE DispBegin()               => MDispBegin()
#XTRANSLATE DispEnd()                 => MDispEnd()

// Additions by Ghostware :
#define LEFT_BUTTON  1
#define RIGHT_BUTTON 2

// Mouse cursor movements :
#define MOVE_NONE        0
#define MOVE_UP          1
#define MOVE_UP_RIGHT    2
#define MOVE_RIGHT       3
#define MOVE_RIGHT_DOWN  4
#define MOVE_DOWN        5
#define MOVE_DOWN_LEFT   6
#define MOVE_LEFT        7
#define MOVE_LEFT_UP     8

// Commands for HOTSPOT functions :
#XCOMMAND DEFINE HOTSPOT [<var>]            ;
	[AT <top>, <left>, <bottom>, <right>]   ;
	[<off:OFF>]                             ;
	[KEY <key>]                             ;
	[DO <do>]                               ;
	[WARM [COLOR] <warmcolor>]              ;
	[COLD [COLOR] <coldcolor>]              ;
	=>                                ;
	[<var> :=] GWHotspot({<top>, <left>,    ;
	<bottom>, <right>}, <key>, <.off.>,     ;
	<{do}>, <warmcolor>, <coldcolor>)

#XCOMMAND WARM HOTSPOT <var>              ;
	=>                                ;
	GWWarmSpot(<var>)

#XCOMMAND WARM ALL HOTSPOTS               ;
	=>                                ;
	GWWarmAllSpots()

#XCOMMAND COOL HOTSPOT <var>              ;
	=>                                ;
	GWCoolSpot(<var>)

#XCOMMAND COOL ALL HOTSPOTS               ;
	=>                                ;
	GWCoolAllSpots()

#XCOMMAND DELETE HOTSPOT <var>            ;
	=>                                ;
	GWDelSpot(<var>)

#XCOMMAND DELETE ALL HOTSPOTS             ;
	=>                                ;
	GWDelAllSpots()

#XCOMMAND SAVE HOTSPOTS TO <var>          ;
	[<delete:DELETE>]                       ;
	=>                                ;
	<var> := GWSaveSpot(<.delete.>)

#XCOMMAND RESTORE HOTSPOTS FROM <var>     ;
	[<repaint:REPAINT>]                     ;
	=>                                ;
	GWRestSpot(<var>, <.repaint.>)

#XCOMMAND PAINT HOTSPOTS                  ;
	=>                                ;
	GWPaintSpots()

/*
#define M_RESET       0   // Reset mouse driver and return
                          // status
                          // AX has status, -1 if hardware and software
                          // installed, 0 if not installed.  BX has
                          // number of buttons

#define M_SHOW        1   // Make mouse cursor visible

#define M_REMOVE      2   // Hide mouse cursor

#define M_READ        3   // Get button status and mouse position
                          // BX has button status, bit 0 left button,
                          // bit 1 right button.  bits are 0 if
                          // corresponding button up, 1 if down

#define M_SET_CURS    4   // Set cursor position.

#define M_MOTION     11   // return horizontal and vertical movement
                          // since last call to this function.

// 2 constants use to translate between mickeys and text mode

#define M_CURS_WIDTH  8   // number of 'mickeys' horizontally
                          // per text character

#define M_CURS_HEIGHT 8   // number of 'mickeys' vertically
                          // per text character

// An array of zeroes to assign to a register structure
#define ZERO_REGS    {0, 0, 0, 0, 0, 0, 0}

#define MOUSE_INT    51   // 0x33, mouse interrupt vector.
*/
