/*****************************************************************************
*  Header File : QUERY.CH                                                    *
*                                                                            *
*       Author : R.P.J. van Geest                                            *
*    Copyright : 1994 - (c) GhostWare                                        *
*                                                                            *
*  Description : Header file for statistic options                           *
*                                                                            *
* Date created : 07-02-94       updated : 21-04-94                          *
* Time created : 21:08:46       updated : 21:18:23                          *
*****************************************************************************/

// You can use this statement when compiling with Clipper 5.2
#STDOUT Using QUERY.CH    - version 2.3 by GhostWare (c) 1991-1994

#XCOMMAND STATISTIC [TO] FILE <(cFile)> BREAK [ON] <cBreak> ;
          [<lIndex:INDEX>] ;
  =>      GWqInit(<(cFile)>, <{cBreak}>, <"cBreak">, <.lIndex.>)

#XCOMMAND STATISTIC LABEL <cExpr> TO <cField> ;
  =>      GWqAddField(<cField>, VALTYPE(<cExpr>), MAX(LEN(<cExpr>), 6), 0) ;
          ; GWqLabel(<{cExpr}>, <"cExpr">, <cField>)

#XCOMMAND STATISTIC ;
          COUNT TO <cField> ;
          [LENGTH <nLength>[, <nDecimals>]] ;
          [FOR <cExpr>] ;
  =>      GWqAddField(<cField>, "N", <nLength>, <nDecimals>) ;
          ; GWqCount(<cField>, <{cExpr}>, <"cExpr">)

#XCOMMAND STATISTIC ;
          SUM <cExpr1> ;
          TO <cField> ;
          [LENGTH <nLength>[, <nDecimals>]] ;
          [FOR <cExpr2>] ;
  =>      GWqAddField(<cField>, "N", <nLength>, <nDecimals>) ;
          ; GWqSum(<{cExpr1}>, <"cExpr1">, ;
          <cField>, <{cExpr2}>, <"cExpr2">)

#XCOMMAND STATISTIC <go:GO, EXECUTE>;
          [<lTotals:TOTALS>] ;
          [<lCounter:COUNTER>] ;
          [FUNCTION <cFunc>] ;
  =>      GWqGo(<.lTotals.>, <.lCounter.>, <{cFunc}>)
