/*
 * File......: STABILIZ.PRG
 * Author....: Martin Colloby
 * BBS.......: The Dark Knight Returns
 * Net/Node..: 050/069
 * User Name.: Martin Colloby
 * Date......: 18/4/93
 * Revision..: 1.0
 *
 * This is an original work by Martin Colloby and is placed in the public
 * domain.
 *
 * Modification history:
 * ---------------------
 *
 * $Log$
 *
 */


/*  $DOC$
 *  $FUNCNAME$
 *      GT_STABILIZE()
 *  $CATEGORY$
 *      General
 *  $ONELINER$
 *      Stabilize a TBrowse object
 *  $SYNTAX$
 *      GT_Stabilize( oObject )
 *  $ARGUMENTS$
 *      oObject - Object to stabilize
 *  $RETURNS$
 *      NIL
 *  $DESCRIPTION$
 *      Stabilizes a TBrowse by DOing a Stabilize
 *  $EXAMPLES$
 *
 *  $SEEALSO$
 *
 *  $INCLUDE$
 *
 *  $END$
 */
*
FUNCTION GT_Stabilize( oObject )

/*****************************************************************************
 Purpose - Stabilize an object
 Returns - None
 Author  - Log
 Created - 22/10/92
******************************************************************************
 Parameters - oObject - Object to stabilize
 Privates   - None
 Locals     - None
 Externals  - None
*****************************************************************************/

DO WHILE .NOT. oObject:stabilize()
ENDDO

RETURN NIL
*
