/*
    The source code contained within this file is protected under the
    laws of the United States of America and by International Treaty.
    Unless otherwise noted, the source contained herein is:

    Copyright (c)1990-1994 BecknerVision Inc - No Rights Reserved

    Written by John Wm Beckner
    BecknerVision Inc

        ** THIS FILE IS PUBLIC DOMAIN **

        ** Use of this code is at your own risk, absolutely no guarantees
        ** are made to its usefulness  - you must determine for yourself if
        ** this code is of any use to you.  If you do not agree with this, do
        ** not use this code. **
*/

#include "beckner.inc"

////////////////
////////////////
//
// Purpose:
//    Eliminate missing external definitions
//
// Syntax:
//    V_Use() -> NIL
//
// Formal Arguments: (0)
//
// Returns:
//    NIL
//
// Files:
//    none
//
// Description:
//    Internal function to eliminate certain missing definitions.
//
// See Also:
//    V_Close()
//    V_Retrieve()
//    V_Replace()
//
// Category:
//    Internal Function
//
// Revisions:
//    01/26/94 Added comment blocks
//
////////////////
////////////////

FUNCTION V_Use()
ENDFUNCTION

////////////////
////////////////
//
// Purpose:
//    Eliminate missing external definitions
//
// Syntax:
//    V_Retrieve() -> NIL
//
// Formal Arguments: (0)
//
// Returns:
//    NIL
//
// Files:
//    none
//
// Description:
//    Internal function to eliminate certain missing definitions.
//
// See Also:
//    V_Close()
//    V_Use()
//    V_Replace()
//
// Category:
//    Internal Function
//
// Revisions:
//    01/26/94 Added comment blocks
//
////////////////
////////////////

FUNCTION V_Retrieve()
ENDFUNCTION

////////////////
////////////////
//
// Purpose:
//    Eliminate missing external definitions
//
// Syntax:
//    V_Close() -> NIL
//
// Formal Arguments: (0)
//
// Returns:
//    NIL
//
// Files:
//    none
//
// Description:
//    Internal function to eliminate certain missing definitions.
//
// See Also:
//    V_Use()
//    V_Retrieve()
//    V_Replace()
//
// Category:
//    Internal Function
//
// Revisions:
//    01/26/94 Added comment blocks
//
////////////////
////////////////

FUNCTION V_Close()
ENDFUNCTION

////////////////
////////////////
//
// Purpose:
//    Eliminate missing external definitions
//
// Syntax:
//    V_Replace() -> NIL
//
// Formal Arguments: (0)
//
// Returns:
//    NIL
//
// Files:
//    none
//
// Description:
//    Internal function to eliminate certain missing definitions.
//
// See Also:
//    V_Close()
//    V_Retrieve()
//    V_Use()
//
// Category:
//    Internal Function
//
// Revisions:
//    01/26/94 Added comment blocks
//
////////////////
////////////////

FUNCTION V_Replace()
ENDFUNCTION
