/*
    The source code contained within this file is protected under the
    laws of the United States of America and by International Treaty.
    Unless otherwise noted, the source contained herein is:

    Copyright (c)1990, 1991, 1992 BecknerVision Inc - All Rights Reserved

    Written by John Wm Beckner        THIS NOTICE MUST NOT BE REMOVED
    BecknerVision Inc
    PO Box 11945                      SOURCE CODE (THIS FILE) MAY NOT BE
    Winston-Salem NC 27116            DISTRIBUTED!  ONLY REGISTERED USERS
    Fax: 919/760-1003                 OF BECKNER LIBRARY & UTILITIES II MAY
                                      BE IN POSSESSION OF THIS FILE.
*/

#include "beckner.inc"

#include "inkey.ch"

FUNCTION vPopWhen(cTitle, cAlias, nStartItem, cReturnExpr, cDisplayExpr,;
      aCoord, cSeekExpr, lAllowNew, bOnZero, bFor, bWhile, nNext,;
      nRecord, lRest)
   LOCAL aList := {}, aRecNum := {}, nChoice := 0, lInUse := .y., uReturn
   LOCAL GetList := {}, nAbort, nCtr
   fSaveFile()
   DEFAULT cDisplayExpr TO cReturnExpr, lAllowNew TO .n.,;
         aCoord TO {7, 45, 20, 78}, nStartItem TO 1
   IF Select(cAlias)>0
      SELECT (Select(cAlias))
   ELSE
      USE (cAlias) NEW SHARED READONLY
      lInUse := .n.
   ENDIF
   IF cSeekExpr!=NIL
      SEEK &cSeekExpr
   ENDIF
   WHILE LOOPING
      dbEval({||aAdd(aRecNum, RecNo()), aAdd(aList, &(cDisplayExpr))},;
            bFor, bWhile, nNext, nRecord, lRest)
      IF !Empty(aRecNum)
         FOR nCtr := 1 to Len(aList)
            IF Empty(aList[nCtr])
               aList[nCtr] := aRecNum[nCtr] := NIL
               iif(nStartItem>=nCtr, nStartItem--,)
            ENDIF
         NEXT
         aPack(aRecNum, .y.)
         aPack(aList, .y.)
         iif(lAllowNew, aAdd(aList, "New Record"),)
         nChoice := aPickList(aCoord[1], aCoord[2], aCoord[3], aCoord[4],;
               aList, nStartItem, cTitle)
         IF nChoice>0
            IF lAllowNew .and. nChoice=Len(aList)
               fFullAdd()
               GO LastRec()
            ELSE
               GO aRecNum[nChoice]
            ENDIF
         ELSEIF nNext!=NIL
            nAbort := Alert("Show more or abort?", {"More", "Abort"})
            IF nAbort!=1
               GO BOTTOM
               IF bOnZero!=NIL
                  RETURN Eval(bOnZero)
               ENDIF
               EXIT
            ENDIF
            aRecNum := {}
            aList   := {}
            LOOP
         ELSE
            GO BOTTOM
            IF bOnZero!=NIL
               RETURN Eval(bOnZero)
            ENDIF
         ENDIF
      ENDIF
      EXIT
   ENDWHILE
   uReturn := &(cReturnExpr)
   IF !lInUse
      CLOSE
   ENDIF
   fRestoreFile()
   RETURN iif(nChoice=0 .and. ValType(uReturn)="N", 0, uReturn)
ENDFUNCTION
